package jp.co.intra_mart.tools.bm5.csv2xml;

import java.io.File;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;

import jp.co.intra_mart.tools.bm5.csv2xml.common.CSVReader;
import jp.co.intra_mart.tools.bm5.csv2xml.common.Config;
import jp.co.intra_mart.tools.bm5.csv2xml.common.Const;
import jp.co.intra_mart.tools.bm5.csv2xml.common.Context;
import jp.co.intra_mart.tools.bm5.csv2xml.common.ContextImpl;
import jp.co.intra_mart.tools.bm5.csv2xml.common.LogManager;
import jp.co.intra_mart.tools.bm5.csv2xml.export.AccountExport;
import jp.co.intra_mart.tools.bm5.csv2xml.export.CompanyExport;
import jp.co.intra_mart.tools.bm5.csv2xml.export.Export;
import jp.co.intra_mart.tools.bm5.csv2xml.export.PostExport;
import jp.co.intra_mart.tools.bm5.csv2xml.export.ProfileExport;
import jp.co.intra_mart.tools.bm5.csv2xml.export.PublicGroupExport;
import jp.co.intra_mart.tools.bm5.csv2xml.models.company.CompanyModelBuilder;
import jp.co.intra_mart.tools.bm5.csv2xml.models.post.CompanyPostModelBuilder;
import jp.co.intra_mart.tools.bm5.csv2xml.models.public_group.PublicGroupModelBuilder;
import jp.co.intra_mart.tools.bm5.csv2xml.models.user.UserModelBuilder;

/**
 * sNX
 * 
 * @since 5.1
 * @author INTRAMART
 * @version 1.0
 */
public class Transform {

	/**
	 * ݒt@CEIuWFNg
	 */
	private static Config config = null;

	/**
	 * ReLXgEIuWFNg
	 */
	private static Context context = null;

	/**
	 * K[IuWFNg
	 */
	private static LogManager logger = null;

	/**
	 * ˑ֌W`FbNp
	 */
	private static Set fileSet = new HashSet();

	/**
	 * s
	 * 
	 * @param args
	 */
	public static void main(String[] args) {

		// ݒt@C̓ǂݍ݁E擾
		Transform.config = Config.getInstance();

		// O}l[W̎擾
		Transform.logger = Config.getLogManager();

		// CSVt@C̓ǂݍ
		Transform.logger.info("SI-001");// Oo
		Transform.readCSVFile();
		Transform.logger.info("SI-002");// Oo

		// f̍쐬
		Transform.createModel();

		// XMLt@C̏o
		Transform.logger.info("SI-003");// Oo
		Transform.ExportXmlFile();
		Transform.logger.info("SI-004");// Oo
	}

	/**
	 * CSVt@C̓ǂݍ
	 * 
	 */
	private static void readCSVFile() {

		File csvRootDir = null;
		File companyDir = null;
		File publicGroupDir = null;
		File userDir = null;

		Map companyMap = null;
		Map postMap = null;
		Map publicGroupMap = null;
		Map userMap = null;

		// ---
		// ReLXg̐
		Transform.context = new ContextImpl();

		// ---
		// CSVt@C̃[gfBNg擾
		csvRootDir = new File(Transform.config.getCsvFilePath());

		if (!csvRootDir.isDirectory()) {
			// CSVt@CpXȂꍇ
			Transform.logger.warning("CW-001", csvRootDir.getAbsolutePath());
			return;
		}

		// ---
		// (company)ApubNO[v(public_group)A[U(user)
		// efBNgpX̎擾ƃfBNg݃`FbN

		// ---
		// CSV̓ǂݍ
		String companyPath = csvRootDir.getAbsolutePath()
				+ "/"
				+ Transform.config
						.getCompanyCSVConfig(Config.TAGNAME_MODEL_NAME)[0]
						.getValue();
		companyDir = new File(companyPath);
		if (!companyDir.isDirectory()) {

			// CSVpfBNgȂꍇ
			Transform.logger.warning("CW-002", companyDir.getAbsolutePath());
		} else {

			// ЃR[hXǧ
			List companyCodeDirList = new ArrayList();
			File[] companySubFiles = companyDir.listFiles();
			for (int i = 0; i < companySubFiles.length; i++) {
				if (companySubFiles[i].isDirectory()) {
					// fBNgXgAbv
					companyCodeDirList.add(companySubFiles[i]);
				}
			}

			if (companyCodeDirList.size() == 0) {
				// ЃR[hEfBNgȂꍇ
				Transform.logger.warning("CW-006");
			}

			// ЃR[hEfBNg[v
			for (int i = 0; i < companyCodeDirList.size(); i++) {
				
				File companyCodeDir = (File) companyCodeDirList.get(i);

				Map companyModelMap = Transform.getModelMap(companyCodeDir);
				
				if (companyModelMap != null) {
					if (companyMap == null) {
						// Зp}bvz쐬
						companyMap = new HashMap();
					}
					
					companyMap.put(companyCodeDir.getName(), companyModelMap);
				}
				
				// EfBNg
				String postDirName = config
						.getPostCSVConfig(Config.TAGNAME_MODEL_NAME)[0]
						.getValue();

				// EtH_
				for (int k = 0; k < companyCodeDir.listFiles().length; k++) {

					File postDir = companyCodeDir.listFiles()[k];

					if (postDir.isDirectory()
							&& postDir.getName().equals(postDirName)) {
						// EfBNgꍇ
						
						Map postModelMap = Transform.getModelMap(postDir);
						
						if (postModelMap != null) {
							if (postMap == null) {
								// EpMapz쐬
								postMap = new HashMap();
							}
	
							postMap.put(companyCodeDir.getName(), postModelMap);
						}
					}
				}

				if (postMap == null) {
					// EpfBNgȂꍇ
					Transform.logger.warning("CW-005", new File(companyCodeDir
							.getAbsolutePath()
							+ "/" + postDirName).getAbsolutePath());
				}
			}
		}

		// ---
		// pubNO[vCSV̓ǂݍ
		String publicGroupPath = csvRootDir.getAbsolutePath()
				+ "/"
				+ Transform.config
						.getPublicGroupCSVConfig(Config.TAGNAME_MODEL_NAME)[0]
						.getValue();

		publicGroupDir = new File(publicGroupPath);
		if (!publicGroupDir.isDirectory()) {
			// pubNO[vCSVpfBNgȂꍇ
			Transform.logger
					.warning("CW-003", publicGroupDir.getAbsolutePath());

		} else {

			// pubNO[vZbgR[hXǧ
			List publicGroupSetCodeDirList = new ArrayList();
			File[] publicGroupSetSubFiles = publicGroupDir.listFiles();
			for (int i = 0; i < publicGroupSetSubFiles.length; i++) {
				if (publicGroupSetSubFiles[i].isDirectory()) {
					// fBNgXgAbv
					publicGroupSetCodeDirList.add(publicGroupSetSubFiles[i]);
				}
			}

			if (publicGroupSetCodeDirList.size() == 0) {
				// pubNO[vZbgR[hEfBNgȂꍇ
				Transform.logger.warning("CW-007");
			}

			// pubNO[vZbgR[hEfBNg[v
			for (int i = 0; i < publicGroupSetCodeDirList.size(); i++) {
				
				File publicGroupSetCodeDir = (File) publicGroupSetCodeDirList
						.get(i);
				
				Map publicGroupModelMap = Transform.getModelMap(publicGroupSetCodeDir);
				
				if (publicGroupModelMap != null) {
					if (publicGroupMap == null) {
						publicGroupMap = new HashMap();
					}
					
					publicGroupMap.put(publicGroupSetCodeDir.getName(), publicGroupModelMap);
				}
			}
		}

		// ---
		// [UCSV̓ǂݍ
		String userPath = csvRootDir.getAbsolutePath()
				+ "/"
				+ Transform.config.getUserCSVConfig(Config.TAGNAME_MODEL_NAME)[0]
						.getValue();
		userDir = new File(userPath);
		if (!userDir.isDirectory()) {
			// [UCSVpfBNgȂꍇ
			Transform.logger.warning("CW-004", userDir.getAbsolutePath());
		}

		userMap = Transform.getModelMap(userDir);

		// ---
		// ReLXgɒlݒ

		// company
		if (companyMap != null) {
			Transform.context.setParameter(config
					.getCompanyCSVConfig(Config.TAGNAME_MODEL_NAME)[0].getValue(),
					companyMap);
		}
		
		// post
		if (postMap != null) {
			Transform.context.setParameter(config
					.getPostCSVConfig(Config.TAGNAME_MODEL_NAME)[0].getValue(),
					postMap);
		}
		
		// publc-group
		if (publicGroupMap != null) {
			Transform.context.setParameter(config
					.getPublicGroupCSVConfig(Config.TAGNAME_MODEL_NAME)[0]
					.getValue(), publicGroupMap);
		}
	
		// user
		if (userMap != null) {
			Transform.context.setParameter(config
					.getUserCSVConfig(Config.TAGNAME_MODEL_NAME)[0].getValue(),
					userMap);
		}
	}

	/**
	 * ۉt@C̃t@C烍P[擾B
	 * 
	 * @param fileName
	 * @return
	 */
	private static String getFileLocale(String fileName) {

		if (fileName.indexOf(Const.INTERNATIONAL_IDENGIFIER) != -1) {
			// ۉt@C̏ꍇ
			List localeList = config.getAllLocale();
			String locale = null;

			// t@C̃P[T
			for (int i = 0; i < localeList.size(); i++) {

				String keyword = Const.INTERNATIONAL_IDENGIFIER + "_"
						+ (String) localeList.get(i) + Const.CSV_SUFFIX;

				if (fileName.indexOf(keyword) != -1) {
					locale = (String) localeList.get(i);
					break;
				}
			}

			if (locale == null) {
				// P[Ȃꍇ
				return null;
			}
			return locale;
		} else {
			// ۉt@Cł͂Ȃꍇ
			return "";
		}
	}

	/**
	 * P[GR[fBO擾B
	 * 
	 * @param locale
	 * @return
	 */
	private static String getFileEncoding(String locale) {
		if (locale != null && locale.length() != 0) {
			// P[GR[fBO擾
			return config.getEncodeing(locale);
		} else {
			// ftHg̃GR[fBO擾
			return config.getEncodeing(config.getDefaultLocale());
		}
	}

	/**
	 * CSVt@CǂݍŃfMap쐬B
	 * 
	 * @param modelDir
	 * @return
	 */
	private static Map getModelMap(File modelDir) {

		if (!modelDir.isDirectory()) {
			return null;
		}

		// CSVReaderCX^X擾
		CSVReader csvReader = CSVReader.getInstance();

		Map modelMap = new HashMap();
		Map i18nMap = new HashMap();
		
		// ۉf[^pL[
		String internationalKey = null;

		// CSVt@C̈ꗗ擾
		File[] fileList = modelDir.listFiles();
		for (int k = 0; k < fileList.length; k++) {
			if (!fileList[k].isFile()
					|| !fileList[k].getName().endsWith(Const.CSV_SUFFIX)) {
				// CSVt@CłȂꍇ̓XLbv
				continue;
			}

			// P[ƃGR[fBO擾
			String locale = Transform.getFileLocale(fileList[k].getName());
			String encoding = Transform.getFileEncoding(locale);

			if (locale == null) {
				// P[܂
				Transform.logger.warning("CW-100", fileList[k]
						.getAbsolutePath());
				continue;
			}

			// CSVt@Cǂݍ
			List csvData = csvReader.getCsvData(fileList[k], encoding);

			if (csvData == null) {
				continue;
			}

			// ˑt@C݂邩ǂׂ
			if (!Transform.checkFileDependence(fileList, fileList[k])) {
				// ˑt@CPł݂Ȃꍇ
				return null;
			}

			// TtBbNX̃t@CiL[j擾
			String fileName = getKeyFromFileName(fileList[k].getName());

			// ǂݍݍς݂brut@Cp̃L[
//			String readCsvKey = null;

			if (fileName.indexOf(Const.INTERNATIONAL_IDENGIFIER) != -1) {
				// ۉt@C̏ꍇ
				internationalKey = fileName;
				i18nMap.put(locale, csvData);
//				readCsvKey = fileName + "_" + locale;
			} else {
				// ۉt@CȊȌꍇ
				modelMap.put(fileName, csvData);
//				readCsvKey = fileName;
			}
			
			// ǂݍݍς݃t@CXgAbv
//			Transform.config.addReadCsvFilePath(readCsvKey, fileList[k]
//					.getAbsolutePath());

		}
		
		if (internationalKey != null) {
			// ۉMapǉ
			modelMap.put(internationalKey, i18nMap);
		}
		
		if (modelMap.isEmpty()) {
			return null;
		}
		
		return modelMap;
	}

	/**
	 * CSVt@Cm̈ˑ֌W`FbN܂B
	 * 
	 * @param fileList
	 * @param file
	 * @return
	 */
	private static boolean checkFileDependence(File[] fileList, File file) {

		// nꂽt@CꗗA݂t@CƂăXgɒǉ
		for (int i = 0; i < fileList.length; i++) {
			Transform.fileSet.add(file.getParentFile().getName()
					+ "/" + getKeyFromFileName(fileList[i].getName()));
		}

		// nꂽL[ɑ΂ĈˑL[擾
		List dependenceList = Transform.config
				.getDependenceKeyList(getKeyFromFileName(file.getName()));

		if (dependenceList == null) {
			// ˑt@Cꍇ
			return true;
		}

		// ȂCSVt@CXg
		List insufficientList = new ArrayList();
		for (int i = 0; i < dependenceList.size(); i++) {

			String checkTarget = file.getParentFile().getName() + "/" + (String) dependenceList.get(i);
			if (!Transform.fileSet.contains(checkTarget)) {
				
//				if(getKeyFromFileName(file.getName()).equals(Const.USER_DEPARTMENT_ATTACH) &&
//						((String) dependenceList.get(i)).equals(Const.DEPARTMENT_TERM))
//				{
//					// ꏈigDt@C̏ꍇ͑gDԏt@CPł΂njj
//					
//				} else if (getKeyFromFileName(file.getName()).equals(Const.USER_PUBLC_GROUP_ATTACH) &&
//						((String) dependenceList.get(i)).equals(Const.PUBLIC_GROUP_TERM_I18N)) {
//					// ꏈiO[vt@C̏ꍇ̓O[vԏt@CPł΂njj
//					
//				}

				// ȊO
				insufficientList.add(checkTarget + Const.CSV_SUFFIX);
			}
		}
		
		if (insufficientList.size() == 0) {
			return true;
		} else {
			String[] msg = new String[2];
			msg[0] = file.getAbsolutePath();
			msg[1] = insufficientList.toString();
			Transform.logger.warning("IW-006", msg);
			return false;
		}
	}

	/**
	 * t@CATtBbNX⃍P[Ԃ܂B
	 * 
	 * @param fileName
	 * @return
	 */
	private static String getKeyFromFileName(String fileName) {
		// TtBbNXAP[t@CiL[j擾
		if (fileName.indexOf(Const.INTERNATIONAL_IDENGIFIER) != -1) {
			return fileName.split(Const.INTERNATIONAL_IDENGIFIER)[0]
					+ Const.INTERNATIONAL_IDENGIFIER;
		} else {
			return fileName.split(Const.CSV_SUFFIX)[0];
		}
	}

	/**
	 * f̃rhs܂B
	 * 
	 */
	private static void createModel() {

		// 
		CompanyModelBuilder companyModelBuilder = new CompanyModelBuilder();
		companyModelBuilder.build(Transform.context);

		// E
		CompanyPostModelBuilder companyPostModelBuilder = new CompanyPostModelBuilder();
		companyPostModelBuilder.build(Transform.context);

		// pubNO[v
		PublicGroupModelBuilder publicGroupBuilder = new PublicGroupModelBuilder();
		publicGroupBuilder.build(Transform.context);

		// [U
		UserModelBuilder userModelBuilder = new UserModelBuilder();
		userModelBuilder.build(Transform.context);
	}

	/**
	 * XMLt@Co͂܂B
	 * 
	 */
	private static void ExportXmlFile() {
		// 
		Export companyExport = new CompanyExport();
		companyExport.createDocument(Transform.context, Const.COMPANY_MODEL,
				Transform.config.getXmlFileName(Const.XMLNAME_COMPANY));

		// E
		Export postExport = new PostExport();
		postExport.createDocument(Transform.context, Const.COMPANY_POST_MODEL,
				Transform.config.getXmlFileName(Const.XMLNAME_POST));

		// pubNO[v
		Export publicGroupExport = new PublicGroupExport();
		publicGroupExport.createDocument(Transform.context,
				Const.PUBLIC_GROUP_MODEL, Transform.config
						.getXmlFileName(Const.XMLNAME_PUBLIC_GROUP));

		// AJEg
		Export accountExport = new AccountExport();
		accountExport.createDocument(Transform.context, Const.USER_MODEL,
				Transform.config.getXmlFileName(Const.XMLNAME_ACCOUT));

		// vt@C
		Export profileExport = new ProfileExport();
		profileExport.createDocument(Transform.context, Const.USER_MODEL,
				Transform.config.getXmlFileName(Const.XMLNAME_PROFILE));
	}
}
