package jp.co.intra_mart.tools.bm5.csv2xml.common;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.List;

import jp.co.intra_mart.tools.bm5.csv2xml.util.CsvFileModel;
import jp.co.intra_mart.tools.bm5.csv2xml.util.CsvUtil;

/**
 * CSVt@C̓ǂݍ݂܂
 * 
 * @since 5.1
 * @author INTRAMART
 * @version 1.0
 */
public class CSVReader {
    
    private static LogManager logger = null;
    
    private static CSVReader csvReader = null;
    
    private CSVReader() {
        CSVReader.logger = Config.getLogManager();
    }
    
    public static CSVReader getInstance() {
        
        if (CSVReader.csvReader == null) {
            CSVReader.csvReader = new CSVReader();
        }
        return CSVReader.csvReader;
    }
    
    public List getCsvData(File inputFile, String encoding){
        
        FileInputStream stream = null;
        String inputFileName = inputFile.getAbsolutePath();
        
        try {
            stream = new FileInputStream(inputFileName);
        } catch (FileNotFoundException e) {
        	// CSVt@CȂꍇ
            CSVReader.logger.warning("IW-001", inputFileName);
            return null;
        }
        
        //-----
        // CSVt@C̓ǂݍ
        
        InputStreamReader ireader = null;
        BufferedReader reader = null;

        try {
            ireader = new InputStreamReader(stream, encoding);
            reader = new BufferedReader(ireader);
            
            // CSVt@C̍sf[^Xg
            CsvFileModel rows = new CsvFileModel();
            
            String line = null;
            while ((line = reader.readLine()) != null) {
                List list = new ArrayList();
                
                if (line.trim().length() == 0) {
                	// 󕶎̓XLbv
                	continue;
                }
                
                // Ps̃f[^J}ŃXvbg
                // XgzƂĎ擾
                list = CsvUtil.toLineSafely(line);
                rows.add(list);
            }
            
            if (rows.size() == 0) {
            	// f[^̏ꍇ
            	CSVReader.logger.warning("IW-004", inputFileName);
            	return null;
            }
            
            // t@CpXǉ
            rows.setFilePath(inputFileName);
            
            // CSVt@C̓ǂݍ݂ɐꍇ
            CSVReader.logger.info("II-001", inputFileName);
            return rows;
            
        } catch (Exception e) {
            // CSVt@C̓ǂݍ݂Ɏsꍇ
            CSVReader.logger.warning("IW-002", inputFileName);
            e.printStackTrace();
            return null;
        } finally {
            try {
                // Xg[
                reader.close();
                ireader.close();
            } catch (IOException e) {
                CSVReader.logger.severe("IW-003", inputFileName);
                e.printStackTrace();
                System.exit(0);
            }
        }
    }
}