package jp.co.intra_mart.tools.bm5.csv2xml.common;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Properties;

import javax.xml.parsers.ParserConfigurationException;

import jp.co.intra_mart.common.aid.jdk.javax.xml.XmlNode;
import jp.co.intra_mart.tools.bm5.csv2xml.util.XmlUtil;

import org.w3c.dom.Document;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.xml.sax.SAXException;

/**
 * ݒt@C̓ǂݍݗpNXł
 * 
 * @since 5.1
 * @author INTRAMART
 * @version 1.0
 */
public class Config {

	private static Config config = null;

	private static final String CONFIG_BASE_PATH = "path";

	private static String ConigBasePath = "";

	// ---
	// CSV

	/**
	 * fBNgpL[
	 */
	public static final String CSV_DIR_NAME = "dir_path";

	/**
	 * 
	 */
	private static final String TAGNAME_TYPE = "type";

	private static final String TAGNAME_NAME = "name";

	private static final String TAGNAME_COMPANY = "company";

	private static final String TAGNAME_POST = "post";

	private static final String TAGNAME_PUBLIC_GROUP = "public-group";

	private static final String TAGNAME_USER = "user";

	private static final String CSV_PATH = "CSV_PATH";

	private static final String XML_PATH = "XML_PATH";

	private static final String LOG_PATH = "LOG_PATH";

	public static final String TAGNAME_MODEL_NAME = "model-name";

	/**
	 * key: "CSV_DIR_NAME" value: dir_name
	 */
	private Map csvPathMap = new HashMap();

	/**
	 * ǂݍݍςCSVt@CpXXg
	 */
//	private Map readCsvFilePathMap = new HashMap();

	/**
	 * ˑ֌W`t@C
	 */
	private Map dependenceConfigMap = null;

	// ---
	// XML
	/**
	 * key: type value: name
	 */
	private Map xmlPathMap = new HashMap();

	// ---
	// GR[fBO

	/**
	 * GR[fBOEXg key: locale value: encoding
	 */
	private Map encodeingMap = new HashMap();

	/**
	 * ftHgP[
	 */
	private String defaultLocale = null;

	// ---
	// [gfBNg
	/**
	 * CSVt@C̓Ǎ
	 */
	private String csvFilePath = null;

	/**
	 * XMLt@C̏o͐
	 */
	private String xmlFilePath = null;

	/**
	 * Ot@C̏o͐
	 */
	private String logFilePath = null;

	/**
	 * RXgN^
	 * 
	 */
	private Config() {

	}

	/**
	 * 擾G[bZ[W
	 */
	private static final String ERR_MSG_GET_FAILED = "̎擾Ɏs܂B";

	/**
	 * CX^X
	 * 
	 * @return
	 */
	public synchronized static Config getInstance() {

		if (Config.config == null) {

			try {
				try {
					// ߂ăCX^X𐶐ꍇ
					Config.config = new Config();

					String configBasePath = System
							.getProperty(CONFIG_BASE_PATH);
					if (configBasePath != null) {
						Config.ConigBasePath = configBasePath + "/";
					}

					// OEvpeBt@CpXݒ
					String logPropPath = new File(Config.config.getConfigPath()
							+ Const.LOGGING_PROP_FILE).getAbsolutePath();

					System.setProperty("java.util.logging.config.file",
							logPropPath);

				} catch (Exception e) {
					System.err.println("Config" + ERR_MSG_GET_FAILED);
					throw e;
				}

				// csv2xml.propertiesǂݍ
				try {
					Config.config.getRootPath();
				} catch (Exception e) {
					System.err.println(Const.CSV2XML_CONFIG_FILE
							+ ERR_MSG_GET_FAILED);
					throw e;
				}

				// config.xmlǂݍ
				try {
					Config.config.getCsvPathList();
				} catch (Exception e) {
					System.err.println(Const.CSV_CONFIG_FILE
							+ ERR_MSG_GET_FAILED);
					throw e;
				}

				// encoing.xmlǂݍ
				try {
					Config.config.getEncoding();
				} catch (Exception e) {
					System.err.println(Const.ENCODING_CONFIG_FILE
							+ ERR_MSG_GET_FAILED);
					throw e;
				}

				// dependence.xmlǂݍ
				try {
					Config.config.getDependenceConfig();
				} catch (Exception e) {
					System.err.println(Const.DEPENDENCE_CONFIG_FILE
							+ ERR_MSG_GET_FAILED);
					throw e;
				}
				

			} catch (Exception e) {
				e.printStackTrace();
				System.exit(0);
			}
		}
		return Config.config;
	}

	/**
	 * O}l[W擾܂B
	 * 
	 * @return
	 */
	public static LogManager getLogManager() {
		try {
			return LogManager.getInstance();
		} catch (RuntimeException e) {
			System.err.println("LogManager" + ERR_MSG_GET_FAILED);
			e.printStackTrace();
			System.exit(0);
			return null;
		}
	}

	/**
	 * conffBNg̃pXԋp܂B
	 * 
	 * @return
	 */
	public String getConfigPath() {
		return Config.ConigBasePath + Const.CONFIG_PATH + "/";
	}

	/**
	 * Ѓf[^CSVt@Cݒ擾܂B
	 * 
	 * @return
	 */
	public XmlNode getCompanyCSVConfig() {
		return (XmlNode) this.csvPathMap.get(Config.TAGNAME_COMPANY);
	}

	/**
	 * Ѓf[^CSVt@Cݒ擾܂B
	 * 
	 * @param key
	 * @return
	 */
	public XmlNode[] getCompanyCSVConfig(String key) {
		return (XmlNode[]) this.getCompanyCSVConfig().select(key);
	}

	/**
	 * Ef[^CSVt@Cݒ擾܂B
	 * 
	 * @return
	 */
	public XmlNode getPostCSVConfig() {
		return (XmlNode) this.csvPathMap.get(Config.TAGNAME_POST);
	}

	/**
	 * Ef[^CSVt@Cݒ擾܂B
	 * 
	 * @param key
	 * @return
	 */
	public XmlNode[] getPostCSVConfig(String key) {
		return (XmlNode[]) this.getPostCSVConfig().select(key);
	}

	/**
	 * pubNO[vf[^CSVt@Cݒ擾܂B
	 * 
	 * @return
	 */
	public XmlNode getPublicGroupCSVConfig() {
		return (XmlNode) this.csvPathMap.get(Config.TAGNAME_PUBLIC_GROUP);
	}

	/**
	 * pubNO[vf[^CSVt@Cݒ擾܂B
	 * 
	 * @param key
	 * @return
	 */
	public XmlNode[] getPublicGroupCSVConfig(String key) {
		return (XmlNode[]) this.getPublicGroupCSVConfig().select(key);
	}

	/**
	 * [Uf[^CSVt@Cݒ擾܂B
	 * 
	 * @return
	 */
	public XmlNode getUserCSVConfig() {
		return (XmlNode) this.csvPathMap.get(Config.TAGNAME_USER);
	}

	/**
	 * [Uf[^CSVt@Cݒ擾܂B
	 * 
	 * @param key
	 * @return
	 */
	public XmlNode[] getUserCSVConfig(String key) {
		return (XmlNode[]) this.getUserCSVConfig().select(key);
	}

	/**
	 * ǂݍݍςCSVt@CpXXgNA܂B
	 * 
	 */
//	public void clearReadCsvFilePath() {
//		this.readCsvFilePathMap = new HashMap();
//	}

	/**
	 * ǂݍݍςCSVt@CpXXgǉ܂B
	 * 
	 * @param key
	 * @param csvFilePathName
	 */
//	public void addReadCsvFilePath(String key, String csvFilePathName) {
//		this.readCsvFilePathMap.put(key, csvFilePathName);
//	}

	/**
	 * ǂݍݍςCSVt@CpX擾܂B
	 * 
	 * @param key
	 * @return
	 */
//	public String getReadCsvFilePath(String key) {
//		return (String) this.readCsvFilePathMap.get(key);
//	}

	/**
	 * ǂݍݍςCSVt@CpXXg擾܂B
	 * 
	 * @return
	 */
//	public Map getAllReadCsvFilePath() {
//		return this.readCsvFilePathMap;
//	}

	/**
	 * ftHgP[擾܂B
	 * 
	 * @return
	 */
	public String getDefaultLocale() {
		return this.defaultLocale;
	}

	/**
	 * GR[fBO擾܂
	 * 
	 * @param local
	 *            P[
	 * @return GR[fBO
	 */
	public String getEncodeing(String local) {
		return (String) this.encodeingMap.get(local);
	}

	/**
	 * ׂẴP[XgŎ擾܂B
	 * 
	 * @return
	 */
	public List getAllLocale() {
		List localeList = new ArrayList();

		Object key[] = this.encodeingMap.keySet().toArray();
		for (int i = 0; i < key.length; i++) {
			localeList.add(key[i]);
		}
		return localeList;
	}

	/**
	 * CSVt@CpX擾܂B
	 * 
	 * @return
	 */
	public String getCsvFilePath() {
		return this.csvFilePath;
	}

	/**
	 * XMLt@CpX擾܂B
	 * 
	 * @return
	 */
	public String getXmlFilePath() {
		return this.xmlFilePath;
	}

	/**
	 * ݒt@CAo͂XMLt@C̃t@C擾܂B
	 * 
	 * @param key
	 * @return
	 */
	public String getXmlFileName(String key) {
		return (String) this.xmlPathMap.get(key);
	}

	/**
	 * Ot@CpX擾܂B
	 * 
	 * @throws IOException
	 */
	public String getLogFilePath() {
		return this.logFilePath;
	}
	
	/**
	 * ˑ֌W`擾܂B
	 */
	public List getDependenceKeyList(String key) {
		return (List)this.dependenceConfigMap.get(key);
	}

	/**
	 * ȉ̃t@CpXvpeBt@C擾܂B <br>
	 * ECSVt@C̓Ǎ <br>
	 * EXMLt@C̏o͐ <br>
	 * EOt@C̏o͐ <br>
	 * 
	 * @throws IOException
	 */
	private void getRootPath() throws IOException {

		Properties property = new Properties();
		property.load(new FileInputStream(new File(this.getConfigPath()
				+ Const.CSV2XML_CONFIG_FILE)));

		this.csvFilePath = property.getProperty(CSV_PATH);
		this.xmlFilePath = property.getProperty(XML_PATH);
		this.logFilePath = property.getProperty(LOG_PATH);

		// CSVt@CpX݂Ȃꍇ̓G[
		File csvPath = new File(this.csvFilePath);
		if (!csvPath.isDirectory()) {
			System.err.println("[" + CSV_PATH + "]" + this.csvFilePath
					+ ERR_MSG_GET_FAILED);
			System.exit(0);
		}

		// Ot@CpX݂Ȃꍇ͐VK쐬
		File logPath = new File(this.logFilePath);
		if (!logPath.isDirectory()) {
			this.createParentDirectory(logPath, null);
		}

		// XMLt@CpX݂Ȃꍇ͐VK쐬
		File xmlPath = new File(this.xmlFilePath);
		if (!xmlPath.isDirectory()) {
			this.createParentDirectory(xmlPath, null);
		}
	}

	/**
	 * fBNgVKɍ쐬܂B
	 * 
	 * @param dir
	 * @param childDirs
	 */
	private void createParentDirectory(File dir, List childDirs) {

		if (childDirs == null) {
			childDirs = new ArrayList();
		}

		File parentDir = dir.getParentFile();

		if (!dir.isDirectory() && parentDir.isDirectory()) {
			dir.mkdir();

			for (int i = childDirs.size() - 1; i >= 0; i--) {
				((File) childDirs.get(i)).mkdir();
			}

			return;
		}

		childDirs.add(dir);
		createParentDirectory(parentDir, childDirs);
	}

	/**
	 * 
	 * @throws SAXException
	 * @throws IOException
	 * @throws ParserConfigurationException
	 */
	private void getCsvPathList() throws Exception {

		String nodeName_csv = "csv";
		String nodeName_xml = "xml";

		// XMlhLg擾
		Document doc = XmlUtil.getDocument(new File(this.getConfigPath()
				+ Const.CSV_CONFIG_FILE));

		// csvm[hxmlm[h
		// <data>
		// <csv>...</csv>
		// <xml>...</xml>
		// </data>
		XmlNode rootNode = new XmlNode(doc).getChildNode()[0];
		XmlNode csvNode = rootNode.select(nodeName_csv)[0];
		XmlNode xmlNode = rootNode.select(nodeName_xml)[0];

		this.csvPathMap.put(Config.TAGNAME_COMPANY, csvNode
				.select(Config.TAGNAME_COMPANY)[0]);
		this.csvPathMap.put(Config.TAGNAME_POST, csvNode
				.select(Config.TAGNAME_POST)[0]);
		this.csvPathMap.put(Config.TAGNAME_PUBLIC_GROUP, csvNode
				.select(Config.TAGNAME_PUBLIC_GROUP)[0]);
		this.csvPathMap.put(Config.TAGNAME_USER, csvNode
				.select(Config.TAGNAME_USER)[0]);

		// oXMLt@Cݒǂݍ
		for (int i = 0; i < xmlNode.getChildNode().length; i++) {

			XmlNode fileNode = xmlNode.getChildNode()[i];
			String file_type = fileNode.select(Config.TAGNAME_TYPE)[0]
					.getValue();
			String file_name = fileNode.select(Config.TAGNAME_NAME)[0]
					.getValue();
			this.xmlPathMap.put(file_type, file_name);
		}
	}

	/**
	 * 
	 * @throws SAXException
	 * @throws IOException
	 * @throws ParserConfigurationException
	 */
	private void getEncoding() throws SAXException, IOException,
			ParserConfigurationException {

		Document doc = XmlUtil.getDocument(new File(this.getConfigPath()
				+ Const.ENCODING_CONFIG_FILE));

		XmlNode[] nodeList = new XmlNode(doc).getNodeList();
		String local = null;
		for (int i = 0; i < nodeList.length; i++) {
			XmlNode childNode = nodeList[i];

			if (childNode.getNodeName().equals("default-locale")) {
				this.defaultLocale = childNode.getValue();
			}

			if (childNode.getNodeName().equals("locale")) {
				local = childNode.getValue();
			}

			if (childNode.getNodeName().equals("code")) {
				this.encodeingMap.put(local, childNode.getValue());
			}
		}
	}
	
	/**
	 * 
	 * @throws Exception
	 */
	private void getDependenceConfig() throws Exception{
		File dependenceConfigFile = new File(Config.config
				.getConfigPath()
				+ Const.DEPENDENCE_CONFIG_FILE);
		Document doc = XmlUtil
				.getDocument(dependenceConfigFile);
		
		NodeList nodeList = doc.getChildNodes();
		
		for (int i = 0; i < nodeList.getLength(); i++) {
			searchChildNodes(nodeList.item(i));
		}
	}
	
	/**
	 * 
	 * @param node
	 */
	private void searchChildNodes(Node node) {
		
		if (!node.hasChildNodes()) {
			return;
		}
		
		NodeList nodeList = node.getChildNodes();
		for (int i = 0; i < nodeList.getLength(); i++) {
			Node childNode = nodeList.item(i);
			
			this.createDependenceMap(childNode);
			this.searchChildNodes(childNode);
		}
	}
	
	/**
	 * 
	 * @param node
	 */
	private void createDependenceMap(Node node) {
		
		List nodeNameList = new ArrayList();
		Node searchNode = node.getParentNode();
		
		while(searchNode.getParentNode().getNodeType() == Node.ELEMENT_NODE) {
			
			nodeNameList.add(searchNode.getNodeName());
			searchNode = searchNode.getParentNode();
		}
		
		if (this.dependenceConfigMap == null) {
			this.dependenceConfigMap = new HashMap();
		}
		
		List oldNodeNameList = (List)this.dependenceConfigMap.get(node.getNodeName());
		
		if (oldNodeNameList != null) {
			for (int i = 0; i < oldNodeNameList.size(); i++) {
				nodeNameList.add(oldNodeNameList.get(i));
			}
		}
		
		this.dependenceConfigMap.put(node.getNodeName(), nodeNameList);
	}
}