package jp.co.intra_mart.tools.bm5.csv2xml.common;

import java.io.File;
import java.io.IOException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.logging.FileHandler;
import java.util.logging.Logger;

/**
 * MOs܂B
 * 
 * @since 5.1
 * @author INTRAMART
 * @version 1.0
 */
public class LogManager {
    /**
     * O}l[W
     */
    private static LogManager manager = null;
    /**
     * K[
     */
    private Logger logger = null;
    
    /**
     * RXgN^
     *
     * CX^X̐͋֎~
     */    
    private LogManager() throws IOException {

        // K[𐶐
        SimpleDateFormat format = new SimpleDateFormat("yyyyMMddHHmmss");
        this.logger = Logger.getLogger(LogManager.class.getName());
        File logDir = new File(Config.getInstance().getLogFilePath());
        File logFile = new File(logDir, Const.logFileName + "_"
                + format.format(new Date()) + ".log");
        
        if (!logDir.isDirectory()) {
        	logDir.mkdir();
        }
        
        FileHandler fileHandler = new FileHandler(logFile.getAbsolutePath(), false);
        //fileHandler.setFormatter(new SimpleFormatter());
        //fileHandler.setLevel(Level.ALL);
        this.logger.addHandler(fileHandler);
    }
    
    /**
     * bZ[W}l[W̃CX^X擾܂B
     * 
     * @return bZ[W}l[W
     */
    public synchronized static LogManager getInstance() {
        if (manager == null) {
            try {
                manager = new LogManager();
            } catch (IOException e) {
            	manager = null;
                throw new RuntimeException(e);
            }
        }
        return manager;
    }
    
    /**
     * INFO bZ[W̃OƂ܂B
     * 
     * @param key bZ[WL[
     */
    public void info(String key) {
        this.logger.info(getMessage(key));
    }

    /**
     * INFO bZ[W̃OƂ܂B
     * 
     * @param key bZ[WL[
     * @param parameter p[^
     */
    public void info(String key, String[] parameter) {
        this.logger.info(getMessage(key, parameter));
    }
    
    /**
     * INFO bZ[W̃OƂ܂B
     * 
     * @param key bZ[WL[
     * @param parameter p[^
     */
    public void info(String key, String parameter) {
    	String[] parameters = new String[1];
    	parameters[0] = parameter;
        this.logger.info(getMessage(key, parameters));
    }

    /**
     * SEVERE bZ[W̃OƂ܂B
     * 
     * @param key bZ[WL[
     */
    public void severe(String key) {
        this.logger.severe(format(key, getMessage(key)));
    }

    /**
     * SEVERE bZ[W̃OƂ܂B
     * 
     * @param key bZ[WL[
     * @param parameter p[^
     */
    public void severe(String key, String[] parameter) {
        this.logger.severe(format(key, getMessage(key, parameter)));
    }
    
    /**
     * SEVERE bZ[W̃OƂ܂B
     * 
     * @param key bZ[WL[
     * @param parameter p[^
     */
    public void severe(String key, String parameter) {
    	String[] parameters = new String[1];
    	parameters[0] = parameter;
        this.logger.severe(format(key, getMessage(key, parameters)));
    }

    /**
     * WARNING bZ[W̃OƂ܂B
     * 
     * @param key bZ[WL[
     */
    public void warning(String key) {
        this.logger.warning(format(key, getMessage(key)));
    }

    /**
     * WARNING bZ[W̃OƂ܂B
     * 
     * @param key bZ[WL[
     * @param parameter p[^
     */
    public void warning(String key, String[] parameter) {
        this.logger.warning(format(key, getMessage(key, parameter)));
    }
    
    /**
     * WARNING bZ[W̃OƂ܂B
     * 
     * @param key bZ[WL[
     * @param parameter p[^
     */
    public void warning(String key, String parameter) {
    	String[] parameters = new String[1];
    	parameters[0] = parameter;
        this.logger.warning(format(key, getMessage(key, parameters)));
    }
    
    /**
     * Oo͗pɃtH[}bg܂B
     * @param key
     * @param message
     * @return
     */
    private String format(String key, String message) {
    	return "[" + key + "] " + message;
    }
    
    /**
     * bZ[W擾܂B
     * 
     * @param key bZ[WL[
     * @return bZ[W
     */
    public String getMessage(String key) {
        return MessageManager.getMessage(key);
    }

    /**
     * bZ[W擾܂B
     * 
     * @param key bZ[WL[
     * @param parameter p[^
     * @return bZ[W
     */
    public String getMessage(String key, String[] parameter) {
        return MessageManager.getMessage(key, parameter);
    }
}
