package jp.co.intra_mart.tools.bm5.csv2xml.export;

import java.util.Iterator;
import java.util.List;

import jp.co.intra_mart.common.aid.jdk.javax.xml.XmlNode;
import jp.co.intra_mart.tools.bm5.csv2xml.models.common.Category;
import jp.co.intra_mart.tools.bm5.csv2xml.models.common.CategoryClass;
import jp.co.intra_mart.tools.bm5.csv2xml.models.common.Term;
import jp.co.intra_mart.tools.bm5.csv2xml.models.common.Version;
import jp.co.intra_mart.tools.bm5.csv2xml.models.company.Company;
import jp.co.intra_mart.tools.bm5.csv2xml.models.company.CompanyMap;
import jp.co.intra_mart.tools.bm5.csv2xml.models.company.Department;
import jp.co.intra_mart.tools.bm5.csv2xml.models.company.DepartmentTerm;
import jp.co.intra_mart.tools.bm5.csv2xml.models.company.DepartmentTermI18n;
import jp.co.intra_mart.tools.bm5.csv2xml.util.XmlUtil;

import org.w3c.dom.Document;

/**
 * ЗpXMLhLg쐬NX
 * 
 * @since 5.1
 * @author INTRAMART
 * @version 1.0
 */
public class CompanyExport extends Export {
    
    /** Ѓf[^ */
    private static final String COMPANY_DATA = "company-data";
    /**  */
    private static final String COMPANY = "company";
    /** ЃR[h */
    private static final String COMPANY_CODE = "company-code";
    /** gD */
    private static final String DEPARTMENT = "department";
    /** gDR[h */
    private static final String DEPARTMENT_CODE = "department-code";
    /** l */
    private static final String NOTES = "notes";
    /** \[gL[ */
    private static final String SORT_KEY = "sort-key";
    /** gD */
    private static final String DEPARTMENT_TERM = "department-term";
    /** LJn */
    private static final String START_DATE = "start-date";
    /** LI */
    private static final String END_DATE = "end-date";
    /** dbԍ */
    private static final String TELEPHONE_NUMBER = "telephone-number";
    /** FAXԍ */
    private static final String FAX_NUMBER = "fax-number";
    /** ԍ */
    private static final String EXTENSION_NUMBER = "extension-number";
    /** FAXԍ */
    private static final String EXTENSION_FAX_NUMBER = "extension-fax-number";
    /** R[h */
    private static final String COUNTRY_CODE = "country-code";
    /** X֔ԍ */
    private static final String ZIP_CODE = "zip-code";
    /** E[AhX1 */
    private static final String EMAI_ADDRESS_1 = "email-address1";
    /** E[AhX2 */
    private static final String EMAI_ADDRESS_2 = "email-address2";
    /** URL */
    private static final String URL = "url";
    /** gDԍۉ */
    private static final String DEPARTMENT_TERM_I18N = "department-term-i18n";
    /**  */
    private static final String LOCALE = "locale";
    /** gD */
    private static final String NAME = "name";
    /** gD */
    private static final String NAME_SYLLABARY = "name-syllabary";
    /** gDp */
    private static final String NAME_ENGLISH = "name-english";
    /** Z1 */
    private static final String ADDRESS_1 = "address1";
    /** Z2 */
    private static final String ADDRESS_2 = "address2";
    /** ދ敪 */
    private static final String CATEGORY_CLASS = "category-class";
    /** ދ敪R[h */
    private static final String CATEGORY_CLASS_CODE = "category-class-code";
    /**  */
    private static final String CATEGORY = "category";
    /** ރR[h */
    private static final String CATEGORY_CODE = "category-code";
    /** ފ */
    private static final String CATEGORY_TERM = "category-term";
    /** Ѓo[W */
    private static final String COMPANY_VERSION = "company-version";
    /** o[WR[h */
    private static final String VERSION_CODE = "version-code";
    /** gD\ */
    private static final String STRUCT = "struct";


	/**
	 * ЂɊւXMLhLgo͂܂B
     * 
	 * @param modelMap 
	 * @return XMLhLg
	 */
	public Document createDocument(Object modelMap) throws Exception {
        // Ѓ}bvɃLXg
        CompanyMap companyMap = (CompanyMap) modelMap;

        // [gݒ
        Document document = XmlUtil.getDocument();
        XmlNode root = new XmlNode(document.createElement(COMPANY_DATA));
        document.appendChild(root.getNode());

        // Џ
        Company[] company = companyMap.getCompany();
        for (int i = 0; i < company.length; i++) {
            XmlNode companyNode = root.addNode(COMPANY);
            // Џ
            setCompanyNode(companyNode, company[i]);

            // o[W
            setVersionNode(companyNode, company[i]);
        }
		return document;
	}
    
    /**
     * Зvf𐶐܂B
     * 
     * @param XML Node
     * @param company 
     */
    private void setCompanyNode(XmlNode node, Company company) {
        
        // ЃR[h
        addNode(node, COMPANY_CODE, company.getCompanyCode());
        
        // gD
        Department[] department = company.getDepartmentList();
        for (int i = 0; i < department.length; i++) {
            XmlNode departmentNode = node.addNode(DEPARTMENT);
            setDepartmentNode(departmentNode, department[i]);
        }
    }
    
    /**
     * gDvf𐶐܂B
     * 
     * @param XML Node
     * @param department gD
     */
    private void setDepartmentNode(XmlNode node, Department department) {
        
        // gDR[h
        addNode(node, DEPARTMENT_CODE, department.getDepartmentCode());
        // l
        addNode(node, NOTES, department.getNotes());
        // \[gL[
        addNode(node, SORT_KEY, department.getSortKey());
        
        // ԉ
        DepartmentTerm[] deptTerm = department.getDeparmentTerms();
        for (int i = 0; i < deptTerm.length; i++) {
            XmlNode deptTermNode = node.addNode(DEPARTMENT_TERM);
            setDepartmentTermNode(deptTermNode, deptTerm[i]);
        }

        // ދ敪
        CategoryClass[] categoryClass = department.getCategoryClasses();
        for (int i = 0; i < categoryClass.length; i++) {
            XmlNode categoryClassNode = node.addNode(CATEGORY_CLASS);
            setCategoryClassNode(categoryClassNode, categoryClass[i]);
        }
    }
    
    /**
     * gDԉvf𐶐܂B
     * 
     * @param XML Node
     * @param departmentTerm gDԉ
     */
    private void setDepartmentTermNode(XmlNode node, DepartmentTerm deptTerm) {
        
        // LJn
        addNode(node, START_DATE, deptTerm.getTerm().getActionvationString());
        // LI
        addNode(node, END_DATE, deptTerm.getTerm().getExpirationString());
        // dbԍ
        addNode(node, TELEPHONE_NUMBER, deptTerm.getTelephoneNumber());
        // FAXԍ
        addNode(node, FAX_NUMBER, deptTerm.getFaxNumber());
        // ԍ
        addNode(node, EXTENSION_NUMBER, deptTerm.getExtensionNumber());
        // FAXԍ
        addNode(node, EXTENSION_FAX_NUMBER, deptTerm.getExtensionFaxNumber());
        // R[h
        addNode(node, COUNTRY_CODE, deptTerm.getCountryCode());
        // X֔ԍ
        addNode(node, ZIP_CODE, deptTerm.getZipCode());
        // E[AhX1
        addNode(node, EMAI_ADDRESS_1, deptTerm.getEmailAddress1());
        // E[AhX2
        addNode(node, EMAI_ADDRESS_2, deptTerm.getEmailAddress2());
        // URL
        addNode(node, URL, deptTerm.getUrl());
        
        DepartmentTermI18n[] deptTermI18n = deptTerm.getTerminableInternationals();
        for (int i = 0; i < deptTermI18n.length; i++) {
            XmlNode deptTermI18nNode = node.addNode(DEPARTMENT_TERM_I18N);
            setDepartmentTermI18nNode(deptTermI18nNode, deptTermI18n[i]);
        }
    }

    /**
     * gDԍۉvf𐶐܂B
     * 
     * @param XML Node
     * @param locale gDԍۉ
     */
    private void setDepartmentTermI18nNode(XmlNode node, DepartmentTermI18n deptTermI18n) {
        
        // 
        addNode(node, LOCALE, deptTermI18n.getLocale().toString());
        // gD
        addNode(node, NAME, deptTermI18n.getName());
        // gDJi
        addNode(node, NAME_SYLLABARY, deptTermI18n.getNameSyllabary());
        // gDp
        addNode(node, NAME_ENGLISH, deptTermI18n.getNameEnglish());
        // Z1
        addNode(node, ADDRESS_1, deptTermI18n.getAddress1());
        // Z2
        addNode(node, ADDRESS_2, deptTermI18n.getAddress2());
    }

    /**
     * Еދ敪vf𐶐܂B
     * 
     * @param XML Node
     * @param category Еދ敪
     */
    private void setCategoryClassNode(XmlNode node, CategoryClass categoryClass) {
        
        // ދ敪R[h
        addNode(node, CATEGORY_CLASS_CODE, categoryClass.getCategoryClassCode());
        
        Category[] category = categoryClass.getCategories();
        for (int i = 0; i < category.length; i++) {
            XmlNode categoryClassNode = node.addNode(CATEGORY);
            setCategoryNode(categoryClassNode, category[i]);
        }
    }

    /**
     * Еޗvf𐶐܂B
     * 
     * @param XML Node
     * @param category ЃJeS
     */
    private void setCategoryNode(XmlNode node, Category category) {
        
        // ރR[h
        addNode(node, CATEGORY_CODE, category.getCategoryCode());

        // ފ
        Term[] term = category.getTerms();
        for (int i = 0; i < term.length; i++) {
            XmlNode termNode = node.addNode(CATEGORY_TERM);
            // LJn
            addNode(termNode, START_DATE, term[i].getActionvationString());
            // LI
            addNode(termNode, END_DATE, term[i].getExpirationString());
        }
    }

    /**
     * Ѓo[Wvf𐶐܂B
     * 
     * @param XML Node
     * @param company 
     */
    private void setVersionNode(XmlNode node, Company company) {
        
        // o[W
        Version[] version = company.getVersions();
        for (int i = 0; i < version.length; i++) {
            XmlNode versionNode = node.addNode(COMPANY_VERSION);

            // o[WR[h
            addNode(versionNode, VERSION_CODE, version[i].getVersionCode());
            // Jn
            addNode(versionNode, START_DATE, version[i].getTerm().getActionvationString());
            // I
            addNode(versionNode, END_DATE, version[i].getTerm().getExpirationString());
            // l
            addNode(versionNode, NOTES, version[i].getNotes());
            
            // Kw\
            setStructNode(versionNode, version[i].getVersionCode(), company.getRoot());
        }
    }

    /**
     * gDKwvf𐶐܂B
     * 
     * @param XML Node
     * @param versionCode o[WR[h
     * @param department gD
     */
    private void setStructNode(XmlNode node, String versionCode, Department department) {
        
        List childlen = department.getChildren(versionCode);
        for (Iterator it = childlen.iterator(); it.hasNext(); ) {
            Department child = (Department) it.next();
            
            XmlNode structNode = node.addNode(STRUCT);
            // gDR[h
            addNode(structNode, DEPARTMENT_CODE, child.getDepartmentCode());
            
            setStructNode(structNode, versionCode, child);
        }
    }
}
