package jp.co.intra_mart.tools.bm5.csv2xml.export;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.util.Locale;

import javax.xml.transform.TransformerException;

import jp.co.intra_mart.common.aid.jdk.javax.xml.XmlNode;
import jp.co.intra_mart.tools.bm5.csv2xml.common.Config;
import jp.co.intra_mart.tools.bm5.csv2xml.common.Const;
import jp.co.intra_mart.tools.bm5.csv2xml.common.Context;
import jp.co.intra_mart.tools.bm5.csv2xml.common.LogManager;
import jp.co.intra_mart.tools.bm5.csv2xml.util.XmlUtil;

import org.w3c.dom.Document;

/**
 * XMLhLg쐬EX[p[NX
 * 
 * @since 5.1
 * @author INTRAMART
 * @version 1.0
 */
public abstract class Export {

	protected LogManager logger = null;

	/**
	 * fXMLhLg쐬܂iʏjB
	 * 
	 * @param context
	 * @param modelKey
	 * @param logger
	 * @return
	 */
	public final void createDocument(Context context, String modelKey,
			String xmlFileName) {

		this.logger = Config.getLogManager();

		xmlFileName = Config.getInstance().getXmlFilePath() + "/" + xmlFileName
				+ Const.XML_SUFFIX;

		// ReLXg烂fIuWFNg擾܂B
		Object modelMap = context.getParameter(modelKey);
		Document doc = null;

		if (modelMap == null) {
			// o͂郂fꍇ
			this.logger.info("OI-002", xmlFileName);
			return;
		}

		try {
			// XMLhLg̐
			doc = this.createDocument(modelMap);
			// XMLhLg̏o
			this.write(doc, xmlFileName);

			// XML̐ɐ܂B
			this.logger.info("OI-001", xmlFileName);
		} catch (Exception e) {
			// XML̐Ɏs܂B
			this.logger.warning("OW-001", xmlFileName);
			e.printStackTrace();
			return;
		}
	}

	/**
	 * XMLt@Co͂܂B
	 * 
	 * @param document
	 *            o͂XMLhLg
	 * @param fileName
	 *            XMLhLgt@C
	 */
	public final void write(Document document, String fileName)
			throws FileNotFoundException, TransformerException {

		if (document == null) {
			return;
		}

		FileOutputStream fos = new FileOutputStream(new File(fileName));

		XmlUtil.write(document, fos);
	}

	/**
	 * Vm[hƒlǉ܂B
	 * 
	 * @param targetNode
	 * @param addNodeName
	 * @param value
	 * @return
	 */
	private XmlNode addNodeValue(XmlNode targetNode, String addNodeName,
			String value) {
		XmlNode newNode = targetNode.addNode(addNodeName);
		newNode.setValue(value);
		return newNode;
	}

	/**
	 * Vm[hƒlǉ܂B
	 * 
	 * @param targetNode
	 * @param addNodeName
	 * @param value
	 * @return
	 */
	public XmlNode addNode(XmlNode targetNode, String addNodeName, String value) {
		if (value != null) {
			return addNodeValue(targetNode, addNodeName, value);
		}
		return null;
	}

	/**
	 * Vm[hƒlǉ܂B
	 * 
	 * @param targetNode
	 * @param addNodeName
	 * @param value
	 * @return
	 */
	public XmlNode addNode(XmlNode targetNode, String addNodeName, int value) {
		return addNodeValue(targetNode, addNodeName, Integer.toString(value));
	}

	/**
	 * Vm[hƒlǉ܂B
	 * 
	 * @param targetNode
	 * @param addNodeName
	 * @param value
	 * @return
	 */
	public XmlNode addNode(XmlNode targetNode, String addNodeName, boolean value) {
		return addNodeValue(targetNode, addNodeName, Boolean.toString(value));
	}

	/**
	 * Vm[hƒlǉ܂B
	 * 
	 * @param targetNode
	 * @param addNodeName
	 * @param value
	 * @return
	 */
	public XmlNode addNode(XmlNode targetNode, String addNodeName, Boolean value) {
		return addNodeValue(targetNode, addNodeName, value.toString());
	}

	/**
	 * Vm[hƒlǉ܂B
	 * 
	 * @param targetNode
	 * @param addNodeName
	 * @param value
	 * @return
	 */
	public XmlNode addNode(XmlNode targetNode, String addNodeName, Locale value) {
		if (value != null) {
			return addNodeValue(targetNode, addNodeName, value.toString());
		}
		return null;
	}

	/**
	 * fXMLhLg쐬܂B
	 * 
	 * @param modelMap
	 *            fIuWFNg
	 * @return o͗pXMLhLg
	 */
	public abstract Document createDocument(Object modelMap) throws Exception;
}
