package jp.co.intra_mart.tools.bm5.csv2xml.export;

import java.util.Iterator;
import java.util.List;

import jp.co.intra_mart.common.aid.jdk.javax.xml.XmlNode;
import jp.co.intra_mart.tools.bm5.csv2xml.models.common.Category;
import jp.co.intra_mart.tools.bm5.csv2xml.models.common.CategoryClass;
import jp.co.intra_mart.tools.bm5.csv2xml.models.common.Term;
import jp.co.intra_mart.tools.bm5.csv2xml.models.common.Version;
import jp.co.intra_mart.tools.bm5.csv2xml.models.public_group.PublicGroup;
import jp.co.intra_mart.tools.bm5.csv2xml.models.public_group.PublicGroupSet;
import jp.co.intra_mart.tools.bm5.csv2xml.models.public_group.PublicGroupSetMap;
import jp.co.intra_mart.tools.bm5.csv2xml.models.public_group.PublicGroupTerm;
import jp.co.intra_mart.tools.bm5.csv2xml.models.public_group.PublicGroupTermI18n;
import jp.co.intra_mart.tools.bm5.csv2xml.util.XmlUtil;

import org.w3c.dom.Document;

/**
 * pubNO[vpXMLhLg쐬NX
 * 
 * @since 5.1
 * @author INTRAMART
 * @version 1.0
 */
public class PublicGroupExport extends Export {

    /** pubNO[vZbgf[^ */
    private static final String PUBLIC_GROUP_SET_DATA = "public-group-set-data";
    /** pubNO[vZbg */
    private static final String PUBLIC_GROUP_SET = "public-group-set";
    /** pubNO[vZbgR[h */
    private static final String PUBLIC_GROUP_SET_CODE = "public-group-set-code";
    /** pubNO[v */
    private static final String PUBLIC_GROUP = "public-group";
    /** pubNO[vR[h */
    private static final String PUBLIC_GROUP_CODE = "public-group-code";
    /** l */
    private static final String NOTES = "notes";
    /** \[gL[ */
    private static final String SORT_KEY = "sort-key";
    /** pubNO[v */
    private static final String PUBLIC_GROUP_TERM = "public-group-term";
    /** LJn */
    private static final String START_DATE = "start-date";
    /** LI */
    private static final String END_DATE = "end-date";
    /** pubNO[vԍۉ */
    private static final String PUBLIC_GROUP_TERM_I18N = "public-group-term-i18n";
    /**  */
    private static final String LOCALE = "locale";
    /** pubNO[v */
    private static final String NAME = "name";
    /** pubNO[v */
    private static final String NAME_SYLLABARY = "name-syllabary";
    /** pubNO[vp */
    private static final String NAME_ENGLISH = "name-english";
    /** ދ敪 */
    private static final String CATEGORY_CLASS = "category-class";
    /** ދ敪R[h */
    private static final String CATEGORY_CLASS_CODE = "category-class-code";
    /**  */
    private static final String CATEGORY = "category";
    /** ރR[h */
    private static final String CATEGORY_CODE = "category-code";
    /** ފ */
    private static final String CATEGORY_TERM = "category-term";
    /** pubNO[vZbgo[W */
    private static final String PUBLIC_GROUP_SET_VERSION = "public-group-set-version";
    /** o[WR[h */
    private static final String VERSION_CODE = "version-code";
    /** pubNO[v\ */
    private static final String STRUCT = "struct";

    /**
     * pubNO[vZbgɊւXMLhLgo͂܂B
     * 
     * @param modelMap pubNO[vZbg̃f
     * @return XMLhLg
     */
    public Document createDocument(Object modelMap) throws Exception {
        // pubNO[vZbg}bvɃLXg
        PublicGroupSetMap groupSetMap = (PublicGroupSetMap) modelMap;

        // [gݒ
        Document document = XmlUtil.getDocument();
        XmlNode root = new XmlNode(document.createElement(PUBLIC_GROUP_SET_DATA));
        document.appendChild(root.getNode());

        // pubNO[vZbg
        PublicGroupSet[] groupSet = groupSetMap.getPublicGroupSet();
        for (int i = 0; i < groupSet.length; i++) {
            XmlNode groupSetNode = root.addNode(PUBLIC_GROUP_SET);
            // pubNO[vZbg
            setPublicGroupSetNode(groupSetNode, groupSet[i]);

            // o[W
            setVersionNode(groupSetNode, groupSet[i]);
        }
        return document;
    }
    
    /**
     * pubNO[vZbgvf𐶐܂B
     * 
     * @param node XML Node
     * @param groupSet pubNO[vZbg
     */
    private void setPublicGroupSetNode(XmlNode node, PublicGroupSet groupSet) {
        
        // pubNO[vZbgR[h
        addNode(node, PUBLIC_GROUP_SET_CODE, groupSet.getPublicGroupSetCode());
        
        // pubNO[v
        PublicGroup[] group = groupSet.getPublicGroupList();
        for (int i = 0; i < group.length; i++) {
            XmlNode departmentNode = node.addNode(PUBLIC_GROUP);
            setPublicGroupNode(departmentNode, group[i]);
        }
    }
    
    /**
     * pubNO[vvf𐶐܂B
     * 
     * @param node XML Node
     * @param group pubNO[v
     */
    private void setPublicGroupNode(XmlNode node, PublicGroup group) {
        
        // pubNO[vR[h
        addNode(node, PUBLIC_GROUP_CODE, group.getPublicGroupCode());
        // l
        addNode(node, NOTES, group.getNotes());
        // \[gL[
        addNode(node, SORT_KEY, group.getSortKey());
        
        // ԉ
        PublicGroupTerm[] groupTerm = group.getTerminables();
        for (int i = 0; i < groupTerm.length; i++) {
            XmlNode groupTermNode = node.addNode(PUBLIC_GROUP_TERM);
            setPublicGroupTermNode(groupTermNode, groupTerm[i]);
        }

        // ދ敪
        CategoryClass[] categoryClass = group.getCategoryClasses();
        for (int i = 0; i < categoryClass.length; i++) {
            XmlNode categoryClassNode = node.addNode(CATEGORY_CLASS);
            setCategoryClassNode(categoryClassNode, categoryClass[i]);
        }
    }
    
    /**
     * pubNO[vԉvf𐶐܂B
     * 
     * @param node XML Node
     * @param groupTerm pubNO[vԉ
     */
    private void setPublicGroupTermNode(XmlNode node, PublicGroupTerm groupTerm) {
        
        // LJn
        addNode(node, START_DATE, groupTerm.getTerm().getActionvationString());
        // LI
        addNode(node, END_DATE, groupTerm.getTerm().getExpirationString());
        
        PublicGroupTermI18n[] groupTermI18n = groupTerm.getTerminableInternationals();
        for (int i = 0; i < groupTermI18n.length; i++) {
            XmlNode groupTermI18nNode = node.addNode(PUBLIC_GROUP_TERM_I18N);
            setPublicGroupTermI18nNode(groupTermI18nNode, groupTermI18n[i]);
        }
    }

    /**
     * pubNO[vԍۉvf𐶐܂B
     * 
     * @param node XML Node
     * @param locale pubNO[vԍۉ
     */
    private void setPublicGroupTermI18nNode(XmlNode node, PublicGroupTermI18n groupTermI18n) {
        
        // 
        addNode(node, LOCALE, groupTermI18n.getLocale().toString());
        // pubNO[v
        addNode(node, NAME, groupTermI18n.getName());
        // pubNO[vJi
        addNode(node, NAME_SYLLABARY, groupTermI18n.getNameSyllabary());
        // pubNO[vp
        addNode(node, NAME_ENGLISH, groupTermI18n.getNameEnglish());
    }

    /**
     * pubNO[vZbgދ敪vf𐶐܂B
     * 
     * @param node XML Node
     * @param category pubNO[vZbgދ敪
     */
    private void setCategoryClassNode(XmlNode node, CategoryClass categoryClass) {
        
        // ދ敪R[h
        addNode(node, CATEGORY_CLASS_CODE, categoryClass.getCategoryClassCode());
        
        Category[] category = categoryClass.getCategories();
        for (int i = 0; i < category.length; i++) {
            XmlNode categoryClassNode = node.addNode(CATEGORY);
            setCategoryNode(categoryClassNode, category[i]);
        }
    }

    /**
     * pubNO[vZbgޗvf𐶐܂B
     * 
     * @param node XML Node
     * @param category pubNO[vZbgJeS
     */
    private void setCategoryNode(XmlNode node, Category category) {
        
        // ރR[h
        addNode(node, CATEGORY_CODE, category.getCategoryCode());

        // ފ
        Term[] term = category.getTerms();
        for (int i = 0; i < term.length; i++) {
            XmlNode termNode = node.addNode(CATEGORY_TERM);
            // LJn
            addNode(termNode, START_DATE, term[i].getActionvationString());
            // LI
            addNode(termNode, END_DATE, term[i].getExpirationString());
        }
    }

    /**
     * pubNO[vZbgo[Wvf𐶐܂B
     * 
     * @param node XML Node
     * @param groupSet pubNO[vZbg
     */
    private void setVersionNode(XmlNode node, PublicGroupSet groupSet) {
        
        // o[W
        Version[] version = groupSet.getVersions();
        for (int i = 0; i < version.length; i++) {
            XmlNode versionNode = node.addNode(PUBLIC_GROUP_SET_VERSION);
            
            // o[WR[h
            addNode(versionNode, VERSION_CODE, version[i].getVersionCode());
            // Jn
            addNode(versionNode, START_DATE, version[i].getTerm().getActionvationString());
            // I
            addNode(versionNode, END_DATE, version[i].getTerm().getExpirationString());
            // l
            addNode(versionNode, NOTES, version[i].getNotes());
            
            // Kw\
            setStructNode(versionNode, version[i].getVersionCode(), groupSet.getRoot());
        }
    }

    /**
     * pubNO[vKwvf𐶐܂B
     * 
     * @param node XML Node
     * @param versionCode o[WR[h
     * @param group pubNO[v
     */
    private void setStructNode(XmlNode node, String versionCode, PublicGroup group) {
        
        List childlen = group.getChildren(versionCode);
        for (Iterator it = childlen.iterator(); it.hasNext(); ) {
            PublicGroup child = (PublicGroup) it.next();
            
            XmlNode structNode = node.addNode(STRUCT);
            // pubNO[vR[h
            addNode(structNode, PUBLIC_GROUP_CODE, child.getPublicGroupCode());
            
            setStructNode(structNode, versionCode, child);
        }
    }
}
