package jp.co.intra_mart.tools.bm5.csv2xml.models.common;

import java.util.List;

import jp.co.intra_mart.tools.bm5.csv2xml.models.company.Department;
import jp.co.intra_mart.tools.bm5.csv2xml.models.company.DepartmentTerm;
import jp.co.intra_mart.tools.bm5.csv2xml.models.company.DepartmentTermI18n;
import jp.co.intra_mart.tools.bm5.csv2xml.models.post.Post;
import jp.co.intra_mart.tools.bm5.csv2xml.models.post.PostTermI18n;
import jp.co.intra_mart.tools.bm5.csv2xml.models.public_group.PublicGroup;
import jp.co.intra_mart.tools.bm5.csv2xml.models.public_group.PublicGroupTermI18n;
import jp.co.intra_mart.tools.bm5.csv2xml.models.user.Account;
import jp.co.intra_mart.tools.bm5.csv2xml.models.user.ApplicationRole;
import jp.co.intra_mart.tools.bm5.csv2xml.models.user.Role;
import jp.co.intra_mart.tools.bm5.csv2xml.models.user.User;
import jp.co.intra_mart.tools.bm5.csv2xml.models.user.UserTerm;
import jp.co.intra_mart.tools.bm5.csv2xml.models.user.UserTermI18n;

/**
 * 
 * @since 5.1
 * @author INTRAMART
 * @version 1.0
 */
public class ModelBuilderHelper {
    /**
     * RXgN^
     *
     */
    private ModelBuilderHelper() {
    }

    /**
     * AJEgf𐶐܂B
     * 
     * @param value AJEgi[郊Xg
     * @return AJEgf
     */
    public static Account getAccount(List value) {
        Account account = new Account((String) value.get(0));
        // P[
        account.setLocale((String) value.get(2));
        // GR[fBO
        account.setEncoding((String) value.get(3));
        // pX[h
        account.setPassword((String) value.get(4));
        // oCpX[h
        account.setMobilePassword((String) value.get(5));
        // l
        account.setNotes((String) value.get(6));
        // L
        account.setTerm((String) value.get(7), (String) value.get(8));
        // OotO
        account.setGoOut((String) value.get(9));
        // Cy[Wp^[
        account.setMainPageParttern((String) value.get(10));
        // J[p^[
        account.setColorParttern((String) value.get(11));
        // CZX
        account.setLicense((String) value.get(12));
        return account;
    }
    
    /**
     * [f𐶐܂B
     * 
     * @param value [i[郊Xg
     * @return [f
     */
    public static Role getRole(List value) {
        Role role = new Role((String) value.get(1));
        role.setTerm((String) value.get(2), (String) value.get(3));
        return role;
    }
    
    /**
     * AvP[V[𐶐܂B
     * 
     * @param value AvP[V[i[郊Xg
     * @return AvP[V[f
     */
    public static ApplicationRole getApplicationRole(List value) {
        return new ApplicationRole((String) value.get(1));
    }
    
    /**
     * [U{f𐶐܂B
     * 
     * @param value [Ȕi[郊Xg
     * @return [Uf
     */
    public static User getUser(List value) {
        User user = new User((String) value.get(0));
        // l
        user.setNotes((String) value.get(1));
        // \[gL[
//        user.setSortKey((String) value.get(0));
        return user;
    }
    
    /**
     * [Uԉf𐶐܂B
     * 
     * @param term 
     * @param value [Ůԉi[郊Xg
     * @return [Uԉf
     */
    public static UserTerm getUserTerm(Term term, List value) {
        UserTerm userTerm = new UserTerm(term);
        // dbԍ
        userTerm.setTelephoneNumber((String) value.get(3));
        // gѓdbԍ
        userTerm.setMobileNumber((String) value.get(4));
        // FAXԍ
        userTerm.setFaxNumber((String) value.get(5));
        // ԍ
        userTerm.setExtensionNumber((String) value.get(6));
        // FAXԍ
        userTerm.setExtensionFaxNumber((String) value.get(7));
        // R[h
        userTerm.setCountryCode((String) value.get(8));
        // X֔ԍ
        userTerm.setZipCode((String) value.get(9));
        // E[AhX1 
        userTerm.setEmailAddress1((String) value.get(10));
        // E[AhX2
        userTerm.setEmailAddress2((String) value.get(11));
        // gу[AhX
        userTerm.setMobileEmailAddress((String) value.get(12));
        // URL
        userTerm.setUrl((String) value.get(13));
        
        return userTerm;
    }
    
    /**
     * [Uԍۉf𐶐܂B
     * 
     * @param locale 
     * @param value [Ůԍۉi[郊Xg
     * @return [Uԍۉf
     */
    public static UserTermI18n getUserTermI18n(String locale, List value) {
        UserTermI18n userTermI18n = new UserTermI18n(locale);
        // O
        userTermI18n.setName((String) value.get(3));
        // OJi
        userTermI18n.setNameSyllabary((String) value.get(4));
        // Op
        userTermI18n.setNameEnglish((String) value.get(5));
        // Z
        userTermI18n.setAddress((String) value.get(6));
        
        return userTermI18n;
    }

    /**
     * gD{f𐶐܂B
     * 
     * @param values gD̏i[郊Xg
     * @return gD{f
     */
    public static Department getDepartment(List values) {
        Department deparment = new Department((String) values.get(0));
        // l
        deparment.setNotes((String) values.get(1));
        // \[gL[
        deparment.setSortKey((String) values.get(2));
        return deparment;        
    }

    /**
     * gDԉf𐶐܂B
     * 
     * @param values gD̏i[郊Xg
     * @return gDԉf
     */
    public static DepartmentTerm getDeparmentTerm(Term term, List values) {
        DepartmentTerm departmentTerm = new DepartmentTerm(term);
        // dbԍ
        departmentTerm.setTelephoneNumber((String) values.get(3));
        // FAXԍ
        departmentTerm.setFaxNumber((String) values.get(4));
        // ԍ
        departmentTerm.setExtensionNumber((String) values.get(5));
        // FAXԍ
        departmentTerm.setExtensionFaxNumber((String) values.get(6));
        // R[h
        departmentTerm.setCountryCode((String) values.get(7));
        // X֔ԍ
        departmentTerm.setZipCode((String) values.get(8));
        // E[AhX1 
        departmentTerm.setEmailAddress1((String) values.get(9));
        // E[AhX2
        departmentTerm.setEmailAddress2((String) values.get(10));
        // URL
        departmentTerm.setUrl((String) values.get(11));
        return departmentTerm;
    }

    /**
     * gDԍۉf𐶐܂B
     * 
     * @param values gD̏i[郊Xg
     * @return gDԉf
     */
    public static DepartmentTermI18n getDepartmentTermI18n(String locale, List values) {
        DepartmentTermI18n departmentTermI18n = new DepartmentTermI18n(locale);
        // O
        departmentTermI18n.setName((String) values.get(3));
        // OJi
        departmentTermI18n.setNameSyllabary((String) values.get(4));
        // Op
        departmentTermI18n.setNameEnglish((String) values.get(5));
        // Z1
        departmentTermI18n.setAddress1((String) values.get(6));
        // Z2
        departmentTermI18n.setAddress2((String) values.get(7));
        return departmentTermI18n;
    }
    
    /**
     * E{f𐶐܂B
     * 
     * @param values Ȅi[郊Xg
     * @return E{f
     */
    public static Post getPost(List values) {
        Post post = new Post((String) values.get(0));
        // l
        post.setNotes((String) values.get(1));
        // \[gL[
        post.setSortKey((String) values.get(2));
        return post;
    }

    /**
     * Eԍۉf𐶐܂B
     * 
     * @param values E̊ԍۉi[郊Xg
     * @return Eԍۉf
     */
    public static PostTermI18n getPostTermI18n(String locale,
            List values) {
        PostTermI18n postTermI18n = new PostTermI18n(locale);
        // E
        postTermI18n.setName((String) values.get(3));
        return postTermI18n;
    }

    /**
     * pubNO[v{f𐶐܂B
     * 
     * @param values pubNO[v̏i[郊Xg
     * @return pubNO[v{f
     */
    public static PublicGroup getPublicGroup(List values) {
        PublicGroup publicGroup = new PublicGroup((String) values.get(0));
        // l
        publicGroup.setNotes((String) values.get(1));
        // \[gL[
        publicGroup.setSortKey((String) values.get(2));
        return publicGroup;        
    }

    /**
     * pubNO[vԍۉf𐶐܂B
     * 
     * @param term 
     * @param locale 
     * @param values pubNO[v̏i[郊Xg
     * @return pubNO[vԍۉf
     */
    public static PublicGroupTermI18n getPublicGroupTermI18n(String locale,
            List values) {
        PublicGroupTermI18n publicGroupTermI18n = new PublicGroupTermI18n(locale);
        // pubNO[v
        publicGroupTermI18n.setName((String) values.get(3));
        // pubNO[vJi
        publicGroupTermI18n.setNameSyllabary((String) values.get(4));
        // pubNO[vp
        publicGroupTermI18n.setNameEnglish((String) values.get(5));
        return publicGroupTermI18n;
    }

    /**
     * ދ敪f𐶐܂B
     * 
     * @param value ދ敪i[郊Xg
     * @return ދ敪f
     */
    public static CategoryClass getCategoryClass(List value) {
        CategoryClass categoryClass = new CategoryClass((String) value.get(1));
        return categoryClass;
    }

    /**
     * ރf𐶐܂B
     * 
     * @param value ޏi[郊Xg
     * @return ރf
     */
    public static Category getCategory(List value) {
        Category category = new Category((String) value.get(2));
        return category;
    }
    
    /**
     * o[Wf𐶐܂B
     * 
     * @param value o[Wi[郊Xg
     * @return o[Wf
     */
    public static Version getVersion(List value) {
        Term term = new Term((String) value.get(1), (String) value.get(2));
        Version version = new Version((String) value.get(0), term);
        version.setNotes((String) value.get(3));
        return version;
    }
}
