package jp.co.intra_mart.tools.bm5.csv2xml.models.common;

import java.util.HashSet;
import java.util.List;
import java.util.Set;

import jp.co.intra_mart.tools.bm5.csv2xml.common.Context;
import jp.co.intra_mart.tools.bm5.csv2xml.common.LogManager;
import jp.co.intra_mart.tools.bm5.csv2xml.util.CsvFileModel;

/**
 * fr_[̒ۃNXłB
 * 
 * @since 5.1
 * @author INTRAMART
 * @version 1.0
 */
public abstract class ModelBuilderTemplate {
    /**
     * ReLXg
     */
    private Context context = null;
    /**
     * G[݂邩ǂ
     */
    private boolean error = false;
    /**
     * ̃t@C
     */
    private String executeFile = null;
    /**
     * G[t@C
     */
    private Set files = new HashSet();
    
    /**
     * f̐s܂B
     * 
     * @param context ReLXg
     */
    public final void build(Context context) {
        this.context = context;
        
        try {
            // ReLXg̓f[^擾
            Object input = this.context.getParameter(getContextReadKey());
            
            // ReLXgɒlݒ肳Ȃꍇ͏I
            if (input == null) {
                return;
            }
            
            // f𐶐
            Object model = createModel(input);
            
            // ReLXgɃfݒ
            if (!isError()) {
                if (getContextWriteKey() != null && model != null) {
                    setModelToContext(getContextWriteKey(), model);
                }
            }
        } finally {
            // ReLXgCSV폜
            this.context.removeParameter(getContextReadKey());
        }
    }
    
    /**
     * ReLXgCSVǂݍނ߂̃L[擾܂B
     * 
     * @return L[
     */
    protected abstract String getContextReadKey();
    
    /**
     * ReLXgɃfނ߂̃L[擾܂B
     * 
     * @return L[
     */
    protected abstract String getContextWriteKey();
    
    /**
     * fs܂B
     * 
     * @param input ̓f[^
     * @return f
     */
    protected abstract Object createModel(Object input);
    
    /**
     * ReLXgɃfݒ肵܂B
     * 
     * @param key 
     * @param model
     */
    protected void setModelToContext(String key, Object model) {
        if (!this.error) {
            this.context.setParameter(key, model);
        }
    }
    
    /**
     * G[ǂ
     * 
     * @return G[ꍇtrueAȊOfalse
     */
    public boolean isError() {
        return this.error;
    }
    
    /**
     * ReLXg擾܂B
     * 
     * @return ReLXg
     */
    protected Context getContext() {
        return this.context;
    }
    
    /**
     * G[bZ[W̃Oo͂܂B
     * 
     * @param key L[
     */
    protected void loggingError(String key) {
        setError();
        LogManager.getInstance().warning(key);
    }

    /**
     * G[bZ[W̃Oo͂܂B
     * 
     * @param key L[
     * @param parameter p[^
     */
    protected void loggingError(String key, String[] parameter) {
        setError();
        LogManager.getInstance().warning(key, parameter);
    }

    /**
     * G[bZ[W̃Oo͂܂B
     * 
     * @param id sԍ
     * @param exception fO
     */
    protected void loggingError(int id, ModelBuilderException e) {
        setError();
        List list = e.getParameter();
        list.add(0, Integer.toString(id));
        loggingError(e.getKey(), (String[]) list.toArray(new String[list.size()]));
    }

    /**
     * ̃t@C̏ݒ肵܂B
     * 
     * @param list ̃t@C̓e\Xg
     */
    protected void setExecuteFile(List list) {
        this.executeFile = ((CsvFileModel) list).getFilePath();
    }

    private void setError() {
        this.error = true;
        if (!this.files.contains(this.executeFile)) {
            LogManager.getInstance().warning("IW-005", this.executeFile);
            files.add(this.executeFile);
        }
    }
}
