/*
 * Term.java
 *
 * Created on 2004/08/03, 14:38:19
 */
package jp.co.intra_mart.tools.bm5.csv2xml.models.common;

import java.io.Serializable;
import java.util.Date;

import jp.co.intra_mart.common.platform.util.DateUtil;

/**
 * LԂ\܂B
 * 
 * LԂ͊JnԂƏIԂ\܂B̎𖞂͈͂LԂƂĔF߂܂B
 * <p>
 * Jn&nbsp;&le;&nbsp;L&nbsp;&lt;&nbsp;I
 * </p>
 * ܂AJnԂƏIԂ͏Ɏ̊֌WłKv܂B
 * <p>
 * Jn&nbsp;&lt;&nbsp;I
 * </p>
 * ݒ肳ꂽJnԂяIԂ̎́A00:00:00 ɐ؂̂Ă܂B<br>
 * AIɗLő (9999/12/31|23:59:59) ݒ肳ꂽꍇ͐؂̂Ă͍s܂B<br>
 * <br>
 * 
 * @since 5.1
 * @author INTRAMART
 * @version 1.0
 */
public class Term implements Comparable, Serializable {

    /** LJn */
    private final Date activation;
    /** LI */
    private final Date expiration;
    
    /** Ԃ̍ŏt */
    private static final Date MIN_DATE;

    /** Ԃ̍őt */
    private static final Date MAX_DATE;
    
    /** VXẽftHg */
    private static final Term defaultTerm;
    
    /** Ԃ̕\ */
    private final String termByString;

    static {
        MIN_DATE = DateUtil.getMinDate();
        MAX_DATE = DateUtil.getMaxDate();
        defaultTerm = new Term(MIN_DATE, MAX_DATE);
    }

    /**
     * RXgN^
     * 
     * @param activation
     *            LԂ̊Jn
     * @param expiration
     *            LԂ̏I
     */
    public Term(String activation, String expiration) {
        this(ValueConverter.toDate("START_DATE", activation), ValueConverter
                .toDate("END_DATE", expiration));
    }
    
    /**
     * Ԃݒ肵܂B
     * 
     * @param activation LԂ̊Jn
     * @param expiration LԂ̏I
     */
    private Term(Date activation, Date expiration) {
        this.activation = activation;
        this.expiration = expiration;
        
        if (this.activation.equals(this.expiration)
                || this.activation.after(this.expiration)) {
            // LJnƗLI̎n񂪐܂B
            throw new ModelBuilderException("DW-005", new String[] {
                    getDateString(activation), getDateString(expiration) });
        }

        termByString = getActionvationString().substring(0, 10) + " - "
                + getExpirationString().substring(0, 10);
    }
    

    /**
     * Óȓtǂ`FbN
     * 
     * @param date
     */
    private boolean validDate(Date date) {
        return MIN_DATE.getTime() <= date.getTime()
                && date.getTime() <= MAX_DATE.getTime();
    }

    private Date checkValidDate(Date date) {
        if (date == null) {
            throw new NullPointerException();
        }
        
        // őLȊO͎؂̂Ă
        final Date converted = (MIN_DATE.equals(date)) ? date : DateUtil
                .convertOnlyDate(date);
        
        if (!validDate(converted)) {
            throw new IllegalArgumentException("");
        }
        return converted;
    }

    /**
     * JnԂ擾܂B
     * 
     * @return Jn
     */
    public Date getActivationDate() {
        return this.activation;
    }

    /**
     * JnԂ̕\擾܂B
     * 
     * @return Jn
     */
    public String getActionvationString() {
        return DateUtil.dateToString(getActivationDate());
    }
    
    /**
     * IԂ擾܂B
     * 
     * @return I
     */
    public Date getExpirationDate() {
        return this.expiration;
    }

    /**
     * IԂ̕\擾܂B
     * 
     * @return I
     */
    public String getExpirationString() {
        return DateUtil.dateToString(getExpirationDate());
    }

    private String getDateString(Date date) {
        return DateUtil.dateToString(date).substring(0, 10);
    }
    
    /**
     * w肳ꂽԓɓĂ邩ǂw肵܂B
     * 
     * @param date
     *            
     * @return w肳ꂽԓɓĂꍇ <code>true</code> AłȂ
     *         <code>false</code>
     * @throws NullPointerException
     *             w肳ꂽt <code>null</code>
     * @throws IllegalArgumentException
     *             sȓtݒ肳ꂽꍇ
     */
    public boolean containsDate(Date date) throws NullPointerException,
            IllegalArgumentException {
        checkValidDate(date);

        return isBeforeOrSame(date) && isAfter(date);

    }

    /**
     * ̊ԂƎw肳ꂽԂr܂B
     * 
     * rԂǂ͊SɈv邩AdȂĂȂ̂ꂩłKv܂BԂ̈ꕔ݂̂dȂĂÅԂ܂Ăꍇ͗O܂B
     * 
     * @param o
     *            rΏƂ̊ԁi {@link Term}j
     * @return ̊ԂŎw肳ꂽԂߋłꍇ͕̐Aꍇ̓[ÅԂŎw肳ꂽԂ薢łꍇ͐̐
     * @throws ClassCastException
     *             w肳ꂽԂ {@link Term}ł͂Ȃ
     * @throws IllegalArgumentException
     *             w肳ꂽԂ̈ꕔdȂĂA܂͈܂Ă
     */
    public int compareTo(Object o) throws ClassCastException,
            IllegalArgumentException {
        Term term = (Term) o;
        if (equals(term)) {
            return 0;
        } else if (term != null && !isBefore(term.getExpirationDate())) {
            return 1;
        } else if (term != null && !isAfter(term.getActivationDate())) {
            return -1;
        } else {
            throw new IllegalArgumentException();
        }
    }

    /**
     * ̗LԂƑ̗LԂǂ܂B
     * 
     * JnԂƏIԂꂼ̗LԂɂĊSɈvĂꍇALԂƂ݂Ȃ܂B
     * 
     * @param obj
     *            rΏۂ̗L
     * @return obj Ɏw肳ꂽLԂƂ̗LԂꍇ <code>true</code> AłȂꍇ
     *         <code>false</code>
     */
    public boolean equals(Object obj) {
        if (obj instanceof Term) {
            Term target = (Term) obj;
            Date targetAc = target.getActivationDate();
            Date targetEx = target.getExpirationDate();
            return this.activation.getTime() == targetAc.getTime()
                    && this.expiration.getTime() == targetEx.getTime();
        }
        return false;
    }

    /**
     * LԂ̃nbVR[hlԂ܂B
     * 
     * @return LԂ̃nbVR[hl
     */
    public int hashCode() {
        return this.activation.hashCode();
    }

    /**
     * IuWFNg̕\Ԃ܂B
     * <br>
     * LJnԂƗLIԂꂼ {@link DateUtil#dateToString(Date)} ŕϊ {@link String} ApnCt(-)ŘAԂ܂B
     * ܂Ã\bh͎̒lƓԂ܂B
     * <p>
     * DateUtil.dateToString(getActivationDate()) + " - " + DateUtil.dateToString(getExpirationDate())
     * </p>
     * 
     * @return ̃IuWFNg̕\
     */
    public String toString() {
    	return termByString;
    }
    
    /**
     * VXẽftHgԂ擾܂B
     * 
     * @return ftHg
     */
    public static Term getDefaultTerm() {
        return defaultTerm;
    }
    
    /**
     * LJnԂw肳ꂽOǂԂ܂B
     * 
     * @param date
     *            
     * @return LJnԂȌꍇ <code>true</code> AȊO <code>false</code>
     */
    private boolean isBefore(Date date) {

        return this.activation.getTime() < date.getTime();
    }

    /**
     * LJnԂw肳ꂽOA܂͓ǂԂ܂B
     * 
     * @param date
     *            
     * @return LJnԂȌꍇ <code>true</code> AȊO <code>false</code>
     */
    private boolean isBeforeOrSame(Date date) {
        return this.activation.getTime() <= date.getTime();
    }

    /**
     * LIԂw肳ꂽOǂԂ܂B
     * 
     * @param date
     *            
     * @return LIԂ̏ꍇ <code>true</code> AȊO <code>false</code>
     */
    private boolean isAfter(Date date) {

        return this.expiration.getTime() > date.getTime();
    }
}