package jp.co.intra_mart.tools.bm5.csv2xml.models.common;

import java.util.Calendar;
import java.util.Date;

import jp.co.intra_mart.tools.bm5.csv2xml.common.LogManager;

/**
 * tH[}bg`FbÑ[eBeBNXłB
 * 
 * @since 5.1
 * @author INTRAMART
 * @version 1.0
 */
public class ValueConverter {
    /**
     * J_
     */
    private static Calendar calendar = null;
    /**
     * őL
     */
    private static final Term term = Term.getDefaultTerm();

    static {
        calendar = Calendar.getInstance();
        calendar.set(Calendar.HOUR_OF_DAY,0);
        calendar.set(Calendar.MINUTE,0);
        calendar.set(Calendar.SECOND,0);
        
        // t̉߂ɍs
        calendar.setLenient(false);
    }
    
    /**
     * lݒ肳Ă邩ǂ
     * 
     * @param value
     */
    public static void checkNull(String key, String value) {
        if (isEmpty(value)) {
            // ͕K{
            throw new ModelBuilderException("DW-001", new String[] { getName(key) });
        }
    }
    
    /**
     * lint^̐lɕϊ܂B
     * 
     * @param value
     * @return
     */
    public static int toInt(String key, String value) {
        try {
            return toInt(value);
        } catch (NumberFormatException e) {
            // lځB
            throw new ModelBuilderException("DW-002", new String[] {
                    getName(key), value });
        }
    }
    
    /**
     * ^Ulɕϊ܂B
     * 
     * @param value
     * @return
     */
    public static Boolean toBoolean(String value, Boolean defaultValue) {
        if (isEmpty(value)) {
            return defaultValue;
        }
        return Boolean.valueOf(value);
    }

    /**
     * yyyy/MM/dd`̓tDate^ɕϊ܂B
     * 
     * @param value
     * @return
     */
    public static synchronized Date toDate(String key, String value) {
        // null`FbN
        checkNull(key, value);
        
        // Lőt̏ꍇ
        if (getExpiration().equals(value)) {
            return term.getExpirationDate();
        }
        
        try {
            String[] time = value.split("/");
            return toDate(toInt(time[0]), toInt(time[1]), toInt(time[2]));
        } catch (ModelBuilderException e) {
            // t̗LԃG[̏ꍇ
            if ("DW-004".equals(e.getKey())) {
                e.addParameter(new String[] { getName(key), getActivation(),
                        getExpiration(), value });
            }
            throw e;
        } catch (IllegalArgumentException e) {
            // ȓt
            throw new ModelBuilderException("DW-006", new String[] {
                    getName(key), value });
        } catch (Exception e) {
            // yyyy/MM/dď`̓t
            throw new ModelBuilderException("DW-003", new String[] {
                    getName(key), value });
        }
    }

    private static boolean isEmpty(String value) {
        return (value == null || value.length() == 0);
    }
    
    private static int toInt(String value) {
        return (isEmpty(value)) ? 0 : Integer.parseInt(value);
    }
    
    private static Date toDate(int year, int month, int day) {
        calendar.set(year, month - 1, day);
        Date date = calendar.getTime();
        
        // tLԓɂ邩H
        if (date.before(Term.getDefaultTerm().getActivationDate())
                || date.after(Term.getDefaultTerm().getExpirationDate())) {
            throw new ModelBuilderException("DW-004");
        }
        return date;
    }
    
    private static String getName(String key) {
        return LogManager.getInstance().getMessage(key);
    }
    
    private static String getActivation() {
        return term.getActionvationString().substring(0, 10);
    }

    private static String getExpiration() {
        return term.getExpirationString().substring(0, 10);
    }
}
