package jp.co.intra_mart.tools.bm5.csv2xml.models.company;

import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Set;

import jp.co.intra_mart.tools.bm5.csv2xml.common.Const;
import jp.co.intra_mart.tools.bm5.csv2xml.models.ModelBuilder;
import jp.co.intra_mart.tools.bm5.csv2xml.models.common.Category;
import jp.co.intra_mart.tools.bm5.csv2xml.models.common.CategoryClass;
import jp.co.intra_mart.tools.bm5.csv2xml.models.common.ModelBuilderException;
import jp.co.intra_mart.tools.bm5.csv2xml.models.common.ModelBuilderHelper;
import jp.co.intra_mart.tools.bm5.csv2xml.models.common.ModelBuilderTemplate;
import jp.co.intra_mart.tools.bm5.csv2xml.models.common.Term;
import jp.co.intra_mart.tools.bm5.csv2xml.models.common.Version;

/**
 * Ѓf̐s܂B
 * 
 * @since 5.1
 * @author INTRAMART
 * @version 1.0
 */
public class CompanyModelBuilder extends ModelBuilderTemplate implements ModelBuilder {

    /**
     * ReLXgCSVǂݍނ߂̃L[擾܂B
     * 
     * @return L[
     */
    protected String getContextReadKey() {
        return Const.COMPANY;
    }

    /**
     * ReLXgɃfނ߂̃L[擾܂B
     * 
     * @return L[
     */
    protected String getContextWriteKey() {
        return Const.COMPANY_MODEL;
    }

    /**
     * f̐s܂B
     * 
     * @param input ̓f[^
     * @return f
     */    
    public Object createModel(Object input) {

        // Ѓfi[}bv
        CompanyMap companyMap = new CompanyMap();
        
        Map root = (Map) input;
        for (Iterator it = root.keySet().iterator(); it.hasNext(); ) {
            String companyCode = (String) it.next();
            
            // ВPʂ̃f[^擾
            Map values = (Map) root.get(companyCode);

            // Ѓf𐶐
            Company company = new Company(companyCode);
            companyMap.addCompany(company);
            
            // {fݒ
            List lines = (List) values.get(Const.DEPARTMENT_BASE);
            setExecuteFile(lines);
            setBaseModel(company, lines);
            
            // ԉfݒ
            lines = (List) values.get(Const.DEPARTMENT_TERM);
            // ԉ񂪐ݒ肳ĂȂꍇAȌ̏XLbv
            if (lines == null) {
                continue;
            }
            setExecuteFile(lines);
            setTermModel(company, lines);
            
            // ԍۉfݒ
            Map locales = (Map) values.get(Const.DEPARTMENT_TERM_I18N);
            if (locales != null) {
                setTermI18nModel(company, locales);
            }
            
            // JeS擾
            lines = (List) values.get(Const.COMPANY_CATEGORY);
            if (lines != null) {
                setExecuteFile(lines);
                setCategoryModel(company, lines);
            }
            
            // o[Wݒ
            lines = (List) values.get(Const.COMPANY_VERSION);
            if (lines != null) {
                setExecuteFile(lines);
                setVersion(company, lines);
            }
            
            // 擾
            lines = (List) values.get(Const.COMPANY_INCLUSION);
            if (lines != null) {
                setExecuteFile(lines);
                setInclusion(company, lines);
            }
        }
        
        return companyMap;
    }
    
    
    /**
     * gD{f擾܂B
     * 
     * @param company 
     * @param list pubNO[v{i[郊Xg
     */
    private void setBaseModel(Company company, List list) {

        for (int i = 0; i < list.size(); i++) {
            List data = (List) list.get(i);
            try {
                Department department = ModelBuilderHelper.getDepartment(data);

                // gDЂɐݒ
                company.addDepartment(department);
            } catch (ModelBuilderException e) {
                // Oo
                loggingError(i + 1, e);
            }
        }

        // Ђݒ肳Ă邩ǂH
        if (!company.existDepartment(company.getCompanyCode())) {
            // Oo
            loggingError("MW-016", new String[]{company.getCompanyCode()});
        }
    }

    /**
     * gDԉf擾܂B
     * 
     * @param company 
     * @param list pubNO[vԉi[郊Xg
     */
    public void setTermModel(Company company, List list) {
        
        for (int i = 0; i < list.size(); i++) {
            List data = (List) list.get(i);
            try {
                // gDR[h
                String departmentCode = (String) data.get(0);
                Department department = company.getDepartment(departmentCode);
                // 
                Term term = new Term((String) data.get(1), (String) data.get(2));
                
                // ԉݒ
                DepartmentTerm departmentTerm = ModelBuilderHelper
                        .getDeparmentTerm(term, data);

                department.addDepartmentTerminable(departmentTerm);
            } catch (ModelBuilderException e) {
                // Oo
                loggingError(i + 1, e);
            }
        }
    }
    
    /**
     * gDԍۉfݒ肵܂B
     * 
     * @param company 
     * @param locales gDԍۉi[}bv
     */
    private void setTermI18nModel(Company company, Map locales) {
        
        for (Iterator it = locales.keySet().iterator(); it.hasNext(); ) {
            String locale = (String) it.next();
            List lines = (List) locales.get(locale);
            setExecuteFile(lines);
            setTermI18nModel(company, locale, lines);
        }
    }
    
    /**
     * gDԍۉfݒ肵܂B
     * 
     * @param company 
     * @param list gDԍۉi[郊Xg
     */
    private void setTermI18nModel(Company company, String locale, List list) {
        
        for (int i = 0; i < list.size(); i++) {
            List value = (List) list.get(i);
            try {
                // gD
                String departmentCode = (String) value.get(0);
                Department department = company.getDepartment(departmentCode);
                // gDԉ
                Term term = new Term((String) value.get(1), (String) value.get(2));
                DepartmentTerm departmentTerm = department.getDepartmentTerm(term);
                
                // ԍۉfǉ
                DepartmentTermI18n model = ModelBuilderHelper.getDepartmentTermI18n(locale, value);

                departmentTerm.addTerminableInternational(model);
            } catch (ModelBuilderException e) {
                // Oo
                loggingError(i + 1, e);
            }
        }
    }
    
    /**
     * gDJeSfݒ肵܂B
     * 
     * @param company 
     * @param list gDJeSi[郊Xg
     */
    private void setCategoryModel(Company company, List list) {

        for (int i = 0; i < list.size(); i++) {
            List value = (List) list.get(i);
            try {
              // gD
              Department department = company.getDepartment((String) value.get(0));
                // ԉ񂪑݂邩ǂH
                if (department.getTerms().length == 0) {
                    // Ώۂ̑gDԉ݂Ȃ
                    throw new ModelBuilderException("MW-017", new String[] {
                            company.getCompanyCode(), department.getDepartmentCode() });
                }

                // 
                Term term = new Term((String) value.get(3), (String) value.get(4));

                // ދ敪ݒ
                CategoryClass categoryClass = department.getCategoryClass((String) value.get(1));
                if (categoryClass == null) {
                    categoryClass = ModelBuilderHelper.getCategoryClass(value);
                    department.addCategoryClass(categoryClass);
                }
                
                // ނݒ
                Category category = categoryClass.getCategory((String) value.get(2));
                if (category == null) {
                    category = ModelBuilderHelper.getCategory(value);
                    categoryClass.addCategory(category);
                }
                category.addTerm(term);
            } catch (ModelBuilderException e) {
                // Oo
                loggingError(i + 1, e);
            }
        }        
    }

    /**
     * gDo[Wݒ肵܂B
     * 
     * @param company 
     * @param list o[Wi[郊Xg
     */
    private void setVersion(Company company, List list) {
        
        for (int i = 0; i < list.size(); i++) {
            List value = (List) list.get(i);
            try {
                // o[Wǉ
                Version version = ModelBuilderHelper.getVersion(value);
                
                // G[ȂꍇɃo[Wǉ
                company.addVersion(version);
            } catch (ModelBuilderException e) {
                // Oo
                loggingError(i + 1, e);
            }
        }        
    }

    /**
     * gDݒ肵܂B
     * 
     * @param company 
     * @param list o[Wi[郊Xg
     */
    private void setInclusion(Company company, List list) {

        // o[W̃Zbg
        Set versions = new HashSet();
        
        for (int i = 0; i < list.size(); i++) {
            List value = (List) list.get(i);
            try {
                // o[WR[h
                String versionCode = (String) value.get(0);
                // qpubNO[vR[h
                String child = (String) value.get(1);
                // epubNO[vR[h
                String parent = (String) value.get(2);
                
                // Kw\z
                company.setStruct(versionCode, parent, child);
                
                if (company.getRoot().getDepartmentCode().equals(child)) {
                    versions.add(versionCode);
                }
            } catch (ModelBuilderException e) {
                // Oo
                loggingError(i + 1, e);
            }
        }
        
        // [gvfݒ肳ꂽǂ
        Version[] version = company.getVersions();
        for (int i = 0; i < version.length; i++) {
            if (!versions.contains(version[i].getVersionCode())) {
                // [gvfݒ肳ĂȂ
                loggingError("MW-024", new String[] { company.getCompanyCode(),
                        version[i].getVersionCode() });
            }
        }        
        
        // \zꂽKw\ǂ
        Map invalidStruct = company.getInvalidStruct();
        if (!invalidStruct.isEmpty()) {
            
            // bZ[W쐬
            StringBuffer buffer = new StringBuffer();
            for (Iterator it = invalidStruct.keySet().iterator(); it.hasNext(); ) {
                String versionCode = (String) it.next();
                buffer.append("[").append(versionCode).append("=[");
                Set set = (Set) invalidStruct.get(versionCode);
                for (Iterator it2 = set.iterator(); it2.hasNext(); ) {
                    buffer.append(((Department) it2.next()).getDepartmentCode());
                    buffer.append(",");
                }
                buffer.delete(buffer.length() - 1, buffer.length());
                buffer.append("]]");
            }

            // Oo
            loggingError("MW-018", new String[]{company.getCompanyCode(), buffer.toString() });
        }
    }
}
