/*
 * Department.java
 *
 * Created on 2005/03/31, 12:00:00
 */
package jp.co.intra_mart.tools.bm5.csv2xml.models.company;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.SortedMap;
import java.util.TreeMap;

import jp.co.intra_mart.tools.bm5.csv2xml.common.Const;
import jp.co.intra_mart.tools.bm5.csv2xml.models.common.CategoryClass;
import jp.co.intra_mart.tools.bm5.csv2xml.models.common.ModelBuilderException;
import jp.co.intra_mart.tools.bm5.csv2xml.models.common.Term;
import jp.co.intra_mart.tools.bm5.csv2xml.models.common.ValueConverter;

/**
 * gD̊{̃f[^舵܂B
 *
 * @author intra-mart
 * @since 5.0
 */
public class Department implements Serializable {
    /**
     * 
     */
    private Company company = null;
    /**
     * gDR[h
     */
    private String departmentCode;
    /**
     * l
     */
    private String notes;
    /**
     * \[gL[
     */
    private int sortKey;
    /**
     * gD̊ԉɊ֘Ã}bv
     */
    private SortedMap terms = new TreeMap();
    /**
     * epubNO[v
     */
    private Map parent = new HashMap();
    /**
     * qpubNO[v
     */
    private Map children = new HashMap();
    /**
     * ދ敪
     */
    private Map categories = new HashMap();

    /**
     * RXgN^
     * 
     * @prama departmentCode gDR[h
     */
    public Department(String departmentCode) {
        ValueConverter.checkNull(Const.DEPARTMENT_CODE, departmentCode);
        this.departmentCode = departmentCode;
    }

    /**
     * Ђݒ肵܂B
     * 
     * @param company 
     */
    public void setCompany(Company company) {
        this.company = company;
    }
    
    /**
     * ЃR[h擾܂B
     * 
     * @return ЃR[h
     */
    public String getCompanyCode() {
        return this.company.getCompanyCode();
    }
    
    /**
     * ԉݒ肵܂B
     * 
     * @param model ԉ
     */
    public void addDepartmentTerminable(DepartmentTerm model) {

        try {
            if (terms.containsKey(model.getTerm())) {
                // łɓo^ς݂̊ԉ񂪂
                throw new ModelBuilderException("MW-008", new String[] {
                        getCompanyCode(), getDepartmentCode(), model.getTerm().toString() });
            }
            
            this.terms.put(model.getTerm(), model);
            model.setDepartment(this);
        } catch (IllegalArgumentException e) {
            // ԂdȂĂꍇ
            throw new ModelBuilderException("MW-019", new String[] {
                    getCompanyCode(), getDepartmentCode(), model.getTerm().toString() });
        }
    }

    /**
     * ԉ̈ꗗ擾܂B
     * 
     * @return ԉ̈ꗗ
     */
    public DepartmentTerm[] getDeparmentTerms() {
        return (DepartmentTerm[]) terms.values().toArray(
                new DepartmentTerm[terms.size()]);
    }

    /**
     * Ԃ̈ꗗ擾܂B
     * 
     * @return Ԃ̈ꗗ
     */
    public Term[] getTerms() {
        return (Term[]) terms.keySet().toArray(new Term[terms.size()]);
    }

    /**
     * w肳ꂽԂɑ΂ԉ擾܂B
     * 
     * @param term 
     * @return ԉ
     */
    public DepartmentTerm getDepartmentTerm(Term term) {
        try {
            if (!terms.containsKey(term)) {
                throw new ModelBuilderException("MW-009", new String[] {
                        getCompanyCode(), getDepartmentCode(), term.toString() });
            }
            return (DepartmentTerm) terms.get(term);
        } catch (IllegalArgumentException e) {
            // Yԉ񂪑݂Ȃ
            throw new ModelBuilderException("MW-009", new String[] {
                    getCompanyCode(), getDepartmentCode(), term.toString() });
        }
	}

    /**
     * gDR[h擾܂B
     * 
     * @return gDR[h
     */
    public String getDepartmentCode() {
        return this.departmentCode;
    }

    /**
     * l擾܂B
     * 
     * @return l
     */
    public String getNotes() {
        return this.notes;
    }

    /**
     * lݒ肵܂B
     * 
     * @param notes l
     */
    public void setNotes(String notes) {
        this.notes = notes;
    }
    /**
     * \[gL[擾܂B
     * 
     * @return \[gL[
     */
    public int getSortKey() {
        return this.sortKey;
    }

    /**
     * \[gL[ݒ肵܂B
     * 
     * @param sortKey \[gL[
     */
    public void setSortKey(String sortKey) {
        this.sortKey = ValueConverter.toInt(Const.SORT_KEY, sortKey);
    }
    
    /**
     * egDݒ肵܂B
     * 
     * @param versionCode o[WR[h
     * @param department gD
     * @return Kw\̃[gƂȂgD
     */
    public Department setParent(String versionCode, Department department) {
        Department root = null;
        if (department != null) {
            // Kw\̃[gvf擾
            root = getStructRoot(versionCode, department);
            this.parent.put(versionCode, department);
        }
        return root;
    }
    
    /**
     * qgDݒ肵܂B
     * 
     * @param versionCode o[WR[h
     * @param department gD
     */
    public void addChild(String versionCode, Department department) {
        if (!this.children.containsKey(versionCode)) {
            this.children.put(versionCode, new ArrayList());
        }
        
        List list = (List) this.children.get(versionCode);
        if (list.contains(department)) {
            // ̑gDłɎqvfđ݂
            throw new ModelBuilderException("MW-010", new String[] {
                    getCompanyCode(), versionCode, getDepartmentCode(),
                    department.getDepartmentCode() });
        }

        list.add(department);
    }
    
    /**
     * qgD̈ꗗԂ܂B
     * 
     * @param versionCode o[WR[h
     * @return gD̈ꗗ
     */
    public List getChildren(String versionCode) {
        if (this.children.containsKey(versionCode)) {
            return (List) this.children.get(versionCode);
        }
        return new ArrayList();
    }

    /**
     * ЃJeSݒ肵܂B
     * 
     * @param categoryClassCode ދ敪R[h
     * @param categoryCode JeSR[h
     * @param term 
     */
    public void addCategoryClass(CategoryClass categoryClass) {
        if (categories.containsKey(categoryClass.getCategoryClassCode())) {
            // ̕ދ敪݂
            throw new ModelBuilderException("MW-011", new String[] {
                    getCompanyCode(), getDepartmentCode(),
                    categoryClass.getCategoryClassCode() });
        }
        categories.put(categoryClass.getCategoryClassCode(), categoryClass);
    }
    
    /**
     * ދ敪擾܂B
     * 
     * @param categoryClassCode ދ敪R[h
     * @return ދ敪
     */
    public CategoryClass getCategoryClass(String categoryClassCode) {
        return (CategoryClass) categories.get(categoryClassCode);
    }
    
    /**
     * ދ敪̈ꗗ擾܂B
     * 
     * @return ދ敪̈ꗗ
     */
    public CategoryClass[] getCategoryClasses() {
        return (CategoryClass[]) categories.values().toArray(new CategoryClass[categories.size()]);
    }

    /**
     * Kw\̃[gvf擾܂B
     * 
     * @param versionCode o[WR[h
     * @param department gD
     * @return Kw\̃[gvf
     */
    private Department getStructRoot(String versionCode, Department department) {
        if (this.parent.containsKey(versionCode)) {
            Department dept = (Department) this.parent.get(versionCode);

            // o[Wŕ̐ew肳ꂽꍇ̓G[
            if (!dept.equals(department)) {
                // łɐegDݒ肳Ă
                throw new ModelBuilderException("MW-012", new String[] {
                        getCompanyCode(), versionCode, department.getDepartmentCode(),
                        dept.getDepartmentCode(), getDepartmentCode() });
            }
        }
        
        // [gƂȂgDT
        return department.getStructRootDepartment(versionCode, this);
    }
    
    /**
     * Kw\̃[ggD擾܂B
     * 
     * Kw\zĂꍇ {@see ModelBuilderException} X[܂B
     * 
     * @param versionCode o[WR[h
     * @param department gD 
     * @return Kw\̃[ggD
     */
    private Department getStructRootDepartment(String versionCode, Department department) {
        if (equals(department)) {
            // zĂ܂
            throw new ModelBuilderException("MW-013", new String[] {
                    getCompanyCode(), versionCode, department.getDepartmentCode() });
        }
        
        // eݒ肳ĂXɏʂ
        if (this.parent.containsKey(versionCode)) {
            return ((Department) parent.get(versionCode))
                    .getStructRootDepartment(versionCode, department);
        } else {
            return this;
        }
    }

    public int hashCode() {
        return this.getDepartmentCode().hashCode();
    }

    public boolean equals(Object obj) {
        if (obj == null || !(obj instanceof Department)) {
            return false;
        }
        return (this.hashCode() == obj.hashCode());
    }
}