/*
 * DepartmentTerminable.java
 *
 * Created on 2005/03/31, 12:00:00
 */
package jp.co.intra_mart.tools.bm5.csv2xml.models.company;

import java.io.Serializable;
import java.util.HashMap;
import java.util.Locale;
import java.util.Map;

import jp.co.intra_mart.tools.bm5.csv2xml.models.common.ModelBuilderException;
import jp.co.intra_mart.tools.bm5.csv2xml.models.common.Term;

/**
 * gD̊ԉ̃f[^舵܂B
 *
 * @author intra-mart
 * @since 5.0
 */
public class DepartmentTerm implements Serializable {
    /**
     * gD
     */
    private Department department = null;
    /**
     * 
     */
    private final Term term;
    /**
     * dbԍ
     */
    private String telephoneNumber;
    /**
     * FAXԍ
     */
    private String faxNumber;
    /**
     * ԍ
     */
    private String extensionNumber;
    /**
     * FAXԍ
     */
    private String extensionFaxNumber;
    /**
     * R[h
     */
    private String countryCode;
    /**
     * X֔ԍ
     */
    private String zipCode;
    /**
     * [AhX1
     */
    private String emailAddress1;
    /**
     * [AhX2
     */
    private String emailAddress2;
    /**
     * URL
     */
    private String url;
    /**
     * gD̊ԍۉɊ֘Ã}bv
     */
    private Map locales = new HashMap();

    
    /**
     * RXgN^
     * 
     * @param term 
     */
    public DepartmentTerm(Term term) {
        this.term = term;
    }
    
    /**
     * ԂԂ܂B
     * 
     * @return 
     */
    public Term getTerm() {
        return this.term;
    }
    
    /**
     * w肳ꂽɑ΂ԍۉݒ肵܂B
     * 
     * @param locale iP[j
     * @param model ԍۉ
     */
    public void addTerminableInternational(DepartmentTermI18n model) {
        if (locales.containsKey(model.getLocale())) {
            // łɓo^ς݂̊ԍۉ񂪂
            throw new ModelBuilderException("MW-014", new String[] {
                    getDepartment().getCompanyCode(),
                    getDepartment().getDepartmentCode(), getTerm().toString(),
                    model.getLocale().toString() });
        }
        this.locales.put(model.getLocale(), model);
    }

    /**
     * w肳ꂽɑ΂ԍۉ擾܂B
     * 
     * @param locale iP[j
     * @return ԍۉ
     */
    public DepartmentTermI18n getTerminableInternational(Locale locale) {
        if (!locales.containsKey(locale)) {
            // Yԍۉ񂪑݂Ȃ
            throw new ModelBuilderException("MW-015", new String[] {
                    getDepartment().getCompanyCode(),
                    getDepartment().getDepartmentCode(), getTerm().toString(),
                    locale.toString() });
        }
        return (DepartmentTermI18n) this.locales.get(locale);
    }
    
    /**
     * ԍۉ̈ꗗ擾܂B
     * 
     * @return ԍۉ̈ꗗ
     */
    public DepartmentTermI18n[] getTerminableInternationals() {
        return (DepartmentTermI18n[]) locales.values().toArray(new DepartmentTermI18n[locales.size()]);
    }

    /**
     * dbԍ擾܂B
     * 
     * @return dbԍ
     */
    public String getTelephoneNumber() {
        return this.telephoneNumber;
    }

    /**
     * dbԍݒ肵܂B
     * 
     * @param telephoneNumber dbԍ
     */
    public void setTelephoneNumber(String telephoneNumber) {
        this.telephoneNumber = telephoneNumber;
    }

    /**
     * FAXԍ擾܂B
     * 
     * @return FAXԍ
     */
    public String getFaxNumber() {
        return this.faxNumber;
    }

    /**
     * FAXԍݒ肵܂B
     * 
     * @param faxNumber FAXԍ
     */
    public void setFaxNumber(String faxNumber) {
        this.faxNumber = faxNumber;
    }

    /**
     * ԍ擾܂B
     * 
     * @return ԍ
     */
    public String getExtensionNumber() {
        return this.extensionNumber;
    }

    /**
     * ԍݒ肵܂B
     * 
     * @param extensionNumber ԍ
     */
    public void setExtensionNumber(String extensionNumber) {
        this.extensionNumber = extensionNumber;
    }

    /**
     * FAXԍ擾܂B
     * 
     * @return FAXԍ
     */
    public String getExtensionFaxNumber() {
        return this.extensionFaxNumber;
    }

    /**
     * FAXԍݒ肵܂B
     * 
     * @param extensionFaxNumber FAXԍ
     */
    public void setExtensionFaxNumber(String extensionFaxNumber) {
        this.extensionFaxNumber = extensionFaxNumber;
    }

    /**
     * R[h擾܂B
     * 
     * @return R[h
     */
    public String getCountryCode() {
        return this.countryCode;
    }

    /**
     * R[hݒ肵܂B
     * 
     * @param countryCode R[h
     */
    public void setCountryCode(String countryCode) {
        this.countryCode = countryCode;
    }

    /**
     * X֔ԍ擾܂B
     * 
     * @return X֔ԍ
     */
    public String getZipCode() {
        return this.zipCode;
    }

    /**
     * X֔ԍݒ肵܂B
     * 
     * @param zipCode X֔ԍ
     */
    public void setZipCode(String zipCode) {
        this.zipCode = zipCode;
    }

    /**
     * [AhX1擾܂B
     * 
     * @return [AhX1
     */
    public String getEmailAddress1() {
        return this.emailAddress1;
    }

    /**
     * [AhX1ݒ肵܂B
     * 
     * @param emailAddress1 [AhX1
     */
    public void setEmailAddress1(String emailAddress1) {
        this.emailAddress1 = emailAddress1;
    }

    /**
     * [AhX2擾܂B
     * 
     * @return [AhX2
     */
    public String getEmailAddress2() {
        return this.emailAddress2;
    }

    /**
     * [AhX2ݒ肵܂B
     * 
     * @param emailAddress2 [AhX2
     */
    public void setEmailAddress2(String emailAddress2) {
        this.emailAddress2 = emailAddress2;
    }

    /**
     * URL擾܂B
     * 
     * @return URL
     */
    public String getUrl() {
        return this.url;
    }

    /**
     * URLݒ肵܂B
     * 
     * @param url URL
     */
    public void setUrl(String url) {
        this.url = url;
    }
    
    /**
     * gDݒ肵܂B
     * 
     * @param department gD
     */
    void setDepartment(Department department) {
        this.department = department;
    }
    
    /**
     * gD擾܂B
     * 
     * @return gD
     */
    Department getDepartment() {
        return this.department;
    }
}