package jp.co.intra_mart.tools.bm5.csv2xml.models.post;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import jp.co.intra_mart.tools.bm5.csv2xml.common.Const;
import jp.co.intra_mart.tools.bm5.csv2xml.models.common.ModelBuilderException;
import jp.co.intra_mart.tools.bm5.csv2xml.models.common.ValueConverter;

/**
 * ЖEێ郂fłB
 * 
 * @since 5.1
 * @author INTRAMART
 * @version 1.0
 */
public class CompanyPost implements Serializable {
    /**
     * ЃR[h
     */
    private final String companyCode;
    /**
     * Eێ}bv
     */
    private Map postMap = new HashMap();
    /**
     * Eێ郊Xg
     */
    private List postList = new ArrayList();
    
    /**
     * RXgN^
     * 
     * @param companyCode ЃR[h
     */
    public CompanyPost(String companyCode) {
        ValueConverter.checkNull(Const.COMPANY_CODE, companyCode);
        this.companyCode = companyCode;
    }
    
    /**
     * ЃR[h擾܂B
     * 
     * @return ЃR[h
     */
    public String getCompanyCode() {
        return this.companyCode;
    }
    
    /**
     * Eݒ肵܂B
     * 
     * @param post E
     */
    public void addPost(Post post) {
        if (postMap.containsKey(post.getPostCode())) {
            // ̖E݂
            throw new ModelBuilderException("MW-102", new String[] {
                    getCompanyCode(), post.getPostCode() });
        }
        postMap.put(post.getPostCode(), post);
        postList.add(post);
        post.setCompanyPost(this);
    }
    
    /**
     * w肳ꂽER[hɈvE擾܂B
     * 
     * @param postCode ER[h
     * @return E
     */
    public Post getPost(String postCode) {
        if (!postMap.containsKey(postCode)) {
            // YE݂Ȃ
            throw new ModelBuilderException("MW-103", new String[] {
                    getCompanyCode(), postCode });
        }
        return (Post) postMap.get(postCode);
    }
    
    /**
     * Ëꗗ擾܂B
     * 
     * @return Ëꗗ
     */
    public Post[] getPosts() {
        return (Post[]) postList.toArray(new Post[postList.size()]);
    }

    public int hashCode() {
        return getCompanyCode().hashCode();
    }
    
    public boolean equals(Object obj) {
        if (obj == null || !(obj instanceof CompanyPost)) {
            return false;
        }
        return (this.hashCode() == obj.hashCode());
    }
}
