package jp.co.intra_mart.tools.bm5.csv2xml.models.post;

import java.util.Iterator;
import java.util.List;
import java.util.Map;

import jp.co.intra_mart.tools.bm5.csv2xml.common.Const;
import jp.co.intra_mart.tools.bm5.csv2xml.models.ModelBuilder;
import jp.co.intra_mart.tools.bm5.csv2xml.models.common.ModelBuilderException;
import jp.co.intra_mart.tools.bm5.csv2xml.models.common.ModelBuilderHelper;
import jp.co.intra_mart.tools.bm5.csv2xml.models.common.ModelBuilderTemplate;
import jp.co.intra_mart.tools.bm5.csv2xml.models.common.Term;

/**
 * ЖẼf̐s܂B
 * 
 * @since 5.1
 * @author INTRAMART
 * @version 1.0
 */
public class CompanyPostModelBuilder extends ModelBuilderTemplate implements ModelBuilder {

    /**
     * ReLXgCSVǂݍނ߂̃L[擾܂B
     * 
     * @return L[
     */
    protected String getContextReadKey() {
        return Const.COMPANY_POST;
    }

    /**
     * ReLXgɃfނ߂̃L[擾܂B
     * 
     * @return L[
     */
    protected String getContextWriteKey() {
        return Const.COMPANY_POST_MODEL;
    }

    /**
     * f̐s܂B
     * 
     * @param input ̓f[^
     * @return f
     */    
    public Object createModel(Object input) {
        
        // ЖEfi[}bv
        CompanyPostMap companyPostMap = new CompanyPostMap();

        // E
        Map root = (Map) input;
        
        for (Iterator it = root.keySet().iterator(); it.hasNext(); ) {
            String companyCode = (String) it.next();
            
            // ВPʂ̃f[^擾
            Map values = (Map) root.get(companyCode);

            // ЖEf𐶐
            CompanyPost companyPost = new CompanyPost(companyCode);
            companyPostMap.addCompanyPost(companyPost);
            
            // {fݒ
            List lines = (List) values.get(Const.COMPANY_POST_BASE);
            setExecuteFile(lines);
            setBaseModel(companyPost, lines);
            
            // ԍۉfݒ
            Map locales = (Map) values.get(Const.COMPANY_POST_TERM_I18N);
            if (locales != null) {
                setTermI18nModel(companyPost, locales);
            }
        }
        
        return companyPostMap;
    }

    /**
     * E{f擾܂B
     * 
     * @param companyPost E
     * @param list E{i[郊Xg
     */
    private void setBaseModel(CompanyPost companyPost, List list) {

        for (int i = 0; i < list.size(); i++) {
            List data = (List) list.get(i);
            try {
                Post post = ModelBuilderHelper.getPost(data);
                
                companyPost.addPost(post);
            } catch (ModelBuilderException e) {
                loggingError(i + 1, e);
            }
        }
    }
    
    /**
     * Eԍۉfݒ肵܂B
     * 
     * @param companyPost E
     * @param locales Eԍۉi[}bv
     */
    private void setTermI18nModel(CompanyPost companyPost, Map locales) {
        
        for (Iterator it = locales.keySet().iterator(); it.hasNext(); ) {
            String locale = (String) it.next();
            List lines = (List) locales.get(locale);
            setExecuteFile(lines);
            setTermI18nModel(companyPost, locale, lines);
        }
    }
    
    /**
     * Eԍۉfݒ肵܂B
     * 
     * @param companyPost E
     * @param list Eԍۉi[郊Xg
     */
    private void setTermI18nModel(CompanyPost companyPost, String locale, List list) {

        for (int i = 0; i < list.size(); i++) {
            List value = (List) list.get(i);
            try {
                // ԍۉf
                PostTermI18n model = ModelBuilderHelper.getPostTermI18n(locale, value);
                // 
                Term term = new Term((String) value.get(1), (String) value.get(2));

                // E
                Post post = companyPost.getPost((String) value.get(0));

                // Eԉ
                PostTerm postTerm = post.getPostTerm(term);
                if (postTerm == null) {
                    postTerm = new PostTerm(term);
                    post.addTerminable(postTerm);
                }
                postTerm.addTerminableInternational(model);
            } catch (ModelBuilderException e) {
                // Oo
                loggingError(i + 1, e);
            }
        }
    }
}
