package jp.co.intra_mart.tools.bm5.csv2xml.models.post;

import java.io.Serializable;
import java.util.SortedMap;
import java.util.TreeMap;

import jp.co.intra_mart.tools.bm5.csv2xml.common.Const;
import jp.co.intra_mart.tools.bm5.csv2xml.models.common.ModelBuilderException;
import jp.co.intra_mart.tools.bm5.csv2xml.models.common.Term;
import jp.co.intra_mart.tools.bm5.csv2xml.models.common.ValueConverter;

/**
 * E{ێ܂B
 * 
 * @since 5.1
 * @author INTRAMART
 * @version 1.0
 */
public class Post implements Serializable {
    /**
     * ЖE
     */
    private CompanyPost companyPost = null;
    /**
     * ER[h
     */
    private final String postCode ;
    /**
     * l
     */
    private String notes = null;
    /**
     * \[gL[
     */
    private int sortKey = 0;
    /**
     * ԍۉfɊւ}bv
     */
    private SortedMap terms = new TreeMap();
    
    /**
     * RXgN^
     * 
     * @param postCode ER[h
     */
    public Post(String postCode) {
        ValueConverter.checkNull(Const.POST_CODE, postCode);
        this.postCode = postCode;
    }
    
    /**
     * ЖEݒ肵܂B
     * 
     * @param companyPost ЖE
     */
    public void setCompanyPost(CompanyPost companyPost) {
        this.companyPost = companyPost;
    }
    
    /**
     * ԉfݒ肵܂B
     * 
     * @param model ԉf
     */
    public void addTerminable(PostTerm model) {
        try {
            if (terms.containsKey(model.getTerm())) {
                // łɓo^ς݂̊ԉ񂪂
                throw new ModelBuilderException("MW-104", new String[] {
                        getCompanyCode(), getPostCode(), model.getTerm().toString() });
            }

            this.terms.put(model.getTerm(), model);
            model.setPost(this);
        } catch (IllegalArgumentException e) {
            // ԂdȂĂꍇ
            throw new ModelBuilderException("MW-105", new String[] {
                    getCompanyCode(), getPostCode(), model.getTerm().toString() });
        }
    }

    /**
     * w肳ꂽԂɑ΂ԉ擾܂B
     * 
     * @param term 
     * @return ԉ
     */
    public PostTerm getPostTerm(Term term) {
        try {
            return (PostTerm) terms.get(term);
        } catch (IllegalArgumentException e) {
            return null;
        }
    }

    /**
     * ԉf̈ꗗ擾܂B
     * 
     * @return Eԉ̈ꗗ
     */
    public PostTerm[] getTerminables() {
        return (PostTerm[]) terms.values().toArray(new PostTerm[terms.size()]);
    }

    /**
     * ЃR[h擾܂B
     * 
     * @return ЃR[h
     */
    public String getCompanyCode() {
        return (companyPost == null) ? null : companyPost.getCompanyCode();
    }
    
    /**
     * ER[h擾܂B
     * 
     * @return ER[h
     */
    public String getPostCode() {
        return postCode;
    }

    /**
     * l擾܂B
     * 
     * @return l
     */
    public String getNotes() {
        return notes;
    }
    
    /**
     * lݒ肵܂B
     * 
     * @return l
     */
    public void setNotes(String notes) {
        this.notes = notes;
    }
    
    /**
     * \[gL[擾܂B
     * 
     * @return \[gL[
     */
    public int getSortKey() {
        return sortKey;
    }

    /**
     * \[gL[ݒ肵܂B
     * 
     * @param \[gL[
     */
    public void setSortKey(String sortKey) {
        this.sortKey = ValueConverter.toInt(Const.SORT_KEY, sortKey);
    }

    public int hashCode() {
        return getPostCode().hashCode();
    }
    
    public boolean equals(Object obj) {
        if (obj == null || !(obj instanceof Post)) {
            return false;
        }
        return (this.hashCode() == obj.hashCode());
    }
}
