package jp.co.intra_mart.tools.bm5.csv2xml.models.public_group;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.SortedMap;
import java.util.TreeMap;

import jp.co.intra_mart.tools.bm5.csv2xml.common.Const;
import jp.co.intra_mart.tools.bm5.csv2xml.models.common.CategoryClass;
import jp.co.intra_mart.tools.bm5.csv2xml.models.common.ModelBuilderException;
import jp.co.intra_mart.tools.bm5.csv2xml.models.common.Term;
import jp.co.intra_mart.tools.bm5.csv2xml.models.common.ValueConverter;

/**
 * pubNO[v̊{fłB
 * 
 * @since 5.1
 * @author INTRAMART
 * @version 1.0
 */
public class PublicGroup implements Serializable {
    /**
     * pubNO[vZbg
     */
    private PublicGroupSet publicGroupSet = null;
    /**
     * O[vR[h
     */
    private String code;
    /**
     * l
     */
    private String notes;
    /**
     * \[gL[
     */
    private int sortKey;
    /**
     * ԍۉfɊւ}bv
     */
    private SortedMap terms = new TreeMap();
    /**
     * epubNO[v
     */
    private Map parent = new HashMap();
    /**
     * qpubNO[v
     */
    private Map children = new HashMap();
    /**
     * ދ敪
     */
    private Map categories = new HashMap();
    
    /**
     * RXgN^
     * 
     * @param publicGroupCode O[vR[h
     */
    public PublicGroup(String publicGroupCode) {
        ValueConverter.checkNull(Const.PUBLIC_GROUP_CODE, publicGroupCode);
        this.code = publicGroupCode;
    }
    
    /**
     * pubNO[vZbgݒ肵܂B
     * 
     * @param publicGroupSet pubNO[vZbg
     */
    void setPublicGroupSet(PublicGroupSet publicGroupSet) {
        this.publicGroupSet = publicGroupSet;
    }
    
    /**
     * pubNO[vZbgR[h擾܂B
     * 
     * @return pubNO[vZbgR[h
     */
    public String getPublicGroupSetCode() {
        return (publicGroupSet == null) ? null : publicGroupSet.getPublicGroupSetCode();
    }
    
    /**
     * ԍۉfݒ肵܂B
     * 
     * @param term 
     * @param locale 
     * @param model ԍۉf
     */
    public void addTerminableInternational(PublicGroupTerm model) {
        try {
            if (terms.containsKey(model.getTerm())) {
                // łɓo^ς݂̊ԉ񂪂
                throw new ModelBuilderException("MW-208", new String[] {
                        getPublicGroupSetCode(), getPublicGroupCode(), model.getTerm().toString() });
            }

            this.terms.put(model.getTerm(), model);
            model.setPublicGroup(this);
        } catch (IllegalArgumentException e) {
            // ԂdȂĂꍇ
            throw new ModelBuilderException("MW-219", new String[] {
                    getPublicGroupSetCode(), getPublicGroupCode(), model.getTerm().toString() });
        }
    }

    /**
     * w肳ꂽԂɑ΂ԉ擾܂B
     * 
     * @param term 
     * @return ԉ
     */
    public PublicGroupTerm getPublicGroupTerm(Term term) {
        try {
            return (PublicGroupTerm) terms.get(term);
        } catch (IllegalArgumentException e) {
            return null;            
        }
    }

    /**
     * ԍۉfi[}bv̈ꗗ擾܂B
     * 
     * @return ԍۉf}bv̈ꗗ
     */
    public PublicGroupTerm[] getTerminables() {
    	return (PublicGroupTerm[]) terms.values().toArray(new PublicGroupTerm[terms.size()]);
    }
    
    /**
     * Ԃ̈ꗗ擾܂B
     * 
     * @return Ԃ̈ꗗ
     */
    public Term[] getTerms() {
    	return (Term[]) terms.keySet().toArray(new Term[terms.size()]);
    }

    /**
     * O[vR[h擾܂B
     * 
     * @return O[vR[h
     */
    public String getPublicGroupCode() {
        return this.code;
    }

    /**
     * l擾܂B
     * 
     * @return l
     */
    public String getNotes() {
        return this.notes;
    }

    /**
     * lݒ肵܂B
     * 
     * @param notes l
     */
    public void setNotes(String notes) {
        this.notes = notes;
    }
    /**
     * \[gL[擾܂B
     * 
     * @return \[gL[
     */
    public int getSortKey() {
        return this.sortKey;
    }

    /**
     * \[gL[ݒ肵܂B
     * 
     * @param sortKey \[gL[
     */
    public void setSortKey(String sortKey) {
        this.sortKey = ValueConverter.toInt(Const.SORT_KEY, sortKey);
    }
    
    /**
     * epubNO[vݒ肵܂B
     * 
     * @param versionCode o[WR[h
     * @param publicGroup pubNO[v
     * @return ݒ肳Kw\̃[gƂȂpubNO[vB
     */
    public PublicGroup setParent(String versionCode, PublicGroup publicGroup) {
        PublicGroup root = null;
        if (publicGroup != null) {
            // Kw\̃[gvf擾
            root = getStructRoot(versionCode, publicGroup);
            this.parent.put(versionCode, publicGroup);
        }
        return root;
    }
    
    /**
     * qpubNO[vݒ肵܂B
     * 
     * @param versionCode o[WR[h
     * @param publicGroup pubNO[v
     */
    public void addChild(String versionCode, PublicGroup publicGroup) {
        if (!this.children.containsKey(versionCode)) {
            this.children.put(versionCode, new ArrayList());
        }
        
        List list = (List) this.children.get(versionCode);
        if (list.contains(publicGroup)) {
            // ̃O[vłɎqvfđ݂
            throw new ModelBuilderException("MW-210", new String[] {
                    getPublicGroupSetCode(), versionCode, getPublicGroupCode(),
                    publicGroup.getPublicGroupCode() });
        }

        list.add(publicGroup);
    }
    
    /**
     * qpubNO[v̈ꗗԂ܂B
     * 
     * @param versionCode o[WR[h
     * @return pubNO[v̈ꗗ
     */
    public List getChildren(String versionCode) {
        if (this.children.containsKey(versionCode)) {
            return (List) this.children.get(versionCode);
        }
        return new ArrayList();
    }

    /**
     * pubNO[vJeSݒ肵܂B
     * 
     * @param categoryClassCode ދ敪R[h
     * @param categoryCode JeSR[h
     * @param term 
     */
    public void addCategoryClass(CategoryClass categoryClass) {
        if (categories.containsKey(categoryClass.getCategoryClassCode())) {
            // ̕ދ敪݂
            throw new ModelBuilderException("MW-211", new String[] {
                    getPublicGroupSetCode(), getPublicGroupCode(),
                    categoryClass.getCategoryClassCode() });
        }
        categories.put(categoryClass.getCategoryClassCode(), categoryClass);
    }
    
    /**
     * ދ敪擾܂B
     * 
     * @param categoryClassCode ދ敪R[h
     * @return ދ敪
     */
    public CategoryClass getCategoryClass(String categoryClassCode) {
        return (CategoryClass) categories.get(categoryClassCode);
    }
    
    /**
     * ދ敪̈ꗗ擾܂B
     * 
     * @return ދ敪̈ꗗ
     */
    public CategoryClass[] getCategoryClasses() {
        return (CategoryClass[]) categories.values().toArray(new CategoryClass[categories.size()]);
    }

    /**
     * Kw\̃[gvf擾܂B
     * 
     * @param versionCode o[WR[h
     * @param publicGroup pubNO[v
     * @return Kw\̃[gvf
     */
    private PublicGroup getStructRoot(String versionCode,
            PublicGroup publicGroup) {
        if (parent.containsKey(versionCode)) {
            PublicGroup group = (PublicGroup) parent.get(versionCode);
            
            // o[Wŕ̐ew肳ꂽꍇ̓G[
            if (!group.equals(publicGroup)) {
                // łɐegDݒ肳Ă
                throw new ModelBuilderException("MW-212", new String[] {
                        getPublicGroupSetCode(), versionCode, publicGroup.getPublicGroupCode(),
                        group.getPublicGroupCode(), getPublicGroupCode() });
            }
        }
        
        // [gƂȂO[vT
        return publicGroup.getStructRootGroup(versionCode, this);
    }
    
    /**
     * Kw\̃[gO[v擾܂B
     * 
     * Kw\zĂꍇ {@see FormatException} X[܂B
     * 
     * @param versionCode o[WR[h
     * @param publicGroup pubNO[v 
     * @return Kw\̃[gO[v
     */
    private PublicGroup getStructRootGroup(String versionCode,
            PublicGroup publicGroup) {
        // Ɠꍇ͏zQƂĂ
        if (equals(publicGroup)) {
            // zĂ܂
            throw new ModelBuilderException("MW-213", new String[] {
                    getPublicGroupSetCode(), versionCode,
                    publicGroup.getPublicGroupCode() });
        }
        
        // eݒ肳ĂXɏʂH
        if (parent.containsKey(versionCode)) {
            return ((PublicGroup) parent.get(versionCode)).getStructRootGroup(
                    versionCode, publicGroup);
        } else {
            return this;
        }
    }

    public int hashCode() {
        return this.getPublicGroupCode().hashCode();
    }

    public boolean equals(Object obj) {
        if (obj == null || !(obj instanceof PublicGroup)) {
            return false;
        }
        return (this.hashCode() == obj.hashCode());
    }
}
