package jp.co.intra_mart.tools.bm5.csv2xml.models.public_group;

import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Set;

import jp.co.intra_mart.tools.bm5.csv2xml.common.Const;
import jp.co.intra_mart.tools.bm5.csv2xml.models.ModelBuilder;
import jp.co.intra_mart.tools.bm5.csv2xml.models.common.Category;
import jp.co.intra_mart.tools.bm5.csv2xml.models.common.CategoryClass;
import jp.co.intra_mart.tools.bm5.csv2xml.models.common.ModelBuilderException;
import jp.co.intra_mart.tools.bm5.csv2xml.models.common.ModelBuilderHelper;
import jp.co.intra_mart.tools.bm5.csv2xml.models.common.ModelBuilderTemplate;
import jp.co.intra_mart.tools.bm5.csv2xml.models.common.Term;
import jp.co.intra_mart.tools.bm5.csv2xml.models.common.Version;

/**
 * pubNO[ṽf̐s܂B
 * 
 * @since 5.1
 * @author INTRAMART
 * @version 1.0
 */
public class PublicGroupModelBuilder extends ModelBuilderTemplate implements ModelBuilder {

    /**
     * ReLXgCSVǂݍނ߂̃L[擾܂B
     * 
     * @return L[
     */
    protected String getContextReadKey() {
        return Const.PUBLIC_GROUP;
    }

    /**
     * ReLXgɃfނ߂̃L[擾܂B
     * 
     * @return L[
     */
    protected String getContextWriteKey() {
        return Const.PUBLIC_GROUP_MODEL;
    }

    /**
     * f̐s܂B
     * 
     * @param input ̓f[^
     * @return f
     */    
    public Object createModel(Object input) {
        
        // pubNO[vZbgfi[}bv
        PublicGroupSetMap groupSet = new PublicGroupSetMap();

        // pubNO[v{
        Map root = (Map) input;
        
        for (Iterator it = root.keySet().iterator(); it.hasNext(); ) {
            String groupSetCode = (String) it.next();
            
            // pubNO[vZbgPʂ̃f[^擾
            Map values = (Map) root.get(groupSetCode);

            // pubNO[vZbgf𐶐
            PublicGroupSet publicGroupSet = new PublicGroupSet(groupSetCode);
            groupSet.addPublicGroupSet(publicGroupSet);
            
            // {fݒ
            List lines = (List) values.get(Const.PUBLIC_GROUP_BASE);
            setExecuteFile(lines);
            setBaseModel(publicGroupSet, lines);
            
            // ԍۉfݒ
            Map locales = (Map) values.get(Const.PUBLIC_GROUP_TERM_I18N);
            // ԉ񂪐ݒ肳ĂȂꍇAȌ̏XLbv
            if (locales == null) {
                continue;
            }
            setTermI18nModel(publicGroupSet, locales);
            
            // JeS擾
            lines = (List) values.get(Const.PUBLIC_GROUP_CATEGORY);
            if (lines != null) {
                setExecuteFile(lines);
                setCategoryModel(publicGroupSet, lines);
            }
            
            // o[Wݒ
            lines = (List) values.get(Const.PUBLIC_GROUP_VERSION);
            if (lines != null) {
                setExecuteFile(lines);
                setVersion(publicGroupSet, lines);
            }
            
            // 擾
            lines = (List) values.get(Const.PUBLIC_GROUP_INCLUSION);
            if (lines != null) {
                setExecuteFile(lines);
                setInclusion(publicGroupSet, lines);
            }
        }
        
        return groupSet;
    }
    
    
    /**
     * pubNO[v{f擾܂B
     * 
     * @param publicGroupSet pubNO[vZbg
     * @param list pubNO[v{i[郊Xg
     */
    private void setBaseModel(PublicGroupSet publicGroupSet, List list) {

        for (int i = 0; i < list.size(); i++) {
            List data = (List) list.get(i);
            try {
                PublicGroup publicGroup = ModelBuilderHelper.getPublicGroup(data);
                
                publicGroupSet.addPublicGroup(publicGroup);
            } catch (ModelBuilderException e) {
                // Oo
                loggingError(i + 1, e);
            }
        }
        
        // pubNO[vZbgݒ肳Ă邩ǂ
        if (!publicGroupSet.existPublicGroup(publicGroupSet.getPublicGroupSetCode())) {
            // Oo
            loggingError("MW-216", new String[]{publicGroupSet.getPublicGroupSetCode()});
        }
    }
    
    /**
     * pubNO[vԍۉfݒ肵܂B
     * 
     * @param publicGroupSet pubNO[vZbg
     * @param locales pubNO[vԍۉi[}bv
     */
    private void setTermI18nModel(PublicGroupSet publicGroupSet, Map locales) {
        
        for (Iterator it = locales.keySet().iterator(); it.hasNext(); ) {
            String locale = (String) it.next();
            List lines = (List) locales.get(locale);
            setExecuteFile(lines);
            setTermI18nModel(publicGroupSet, locale, lines);
        }
    }
    
    /**
     * pubNO[vԍۉfݒ肵܂B
     * 
     * @param publicGroupSet pubNO[vZbg
     * @param list pubNO[vԍۉi[郊Xg
     */
    private void setTermI18nModel(PublicGroupSet publicGroupSet, String locale, List list) {
        
        for (int i = 0; i < list.size(); i++) {
            List value = (List) list.get(i);
            try {
                // ԍۉf
                PublicGroupTermI18n model = 
                    ModelBuilderHelper.getPublicGroupTermI18n(locale, value);

                // pubNO[v
                PublicGroup group = publicGroupSet.getPublicGroup((String) value.get(0));
                // 
                Term term = new Term((String) value.get(1), (String) value.get(2));

                // gDԉ
                PublicGroupTerm groupTerm = group.getPublicGroupTerm(term);
                if (groupTerm == null) {
                    groupTerm = new PublicGroupTerm(term);
                    group.addTerminableInternational(groupTerm);
                }
                groupTerm.addTerminableInternational(model);
            } catch (ModelBuilderException e) {
                // Oo
                loggingError(i + 1, e);
            }
        }
    }
    
    /**
     * pubNO[vJeSfݒ肵܂B
     * 
     * @param publicGroupSet pubNO[vZbg
     * @param list pubNO[vJeSi[郊Xg
     */
    private void setCategoryModel(PublicGroupSet publicGroupSet, List list) {

        for (int i = 0; i < list.size(); i++) {
            List value = (List) list.get(i);
            try {
                // pubNO[vR[h
                String publicGroupCode = (String) value.get(0);
                // ԉ񂪑݂邩ǂH
                if (!publicGroupSet.isTerminableGroup(publicGroupCode)) {
                    // Ώۂ̑gDԉ݂Ȃ
                    throw new ModelBuilderException("MW-217", new String[] {
                            publicGroupSet.getPublicGroupSetCode(), publicGroupCode });
                }

                // pubNO[v
                PublicGroup publicGroup = publicGroupSet.getPublicGroup(publicGroupCode);
                // 
                Term term = new Term((String) value.get(3), (String) value.get(4));

                // ދ敪ݒ
                CategoryClass categoryClass = publicGroup.getCategoryClass((String) value.get(1));
                if (categoryClass == null) {
                    categoryClass = ModelBuilderHelper.getCategoryClass(value);
                    publicGroup.addCategoryClass(categoryClass);
                }
                
                // ނݒ
                Category category = categoryClass.getCategory((String) value.get(2));
                if (category == null) {
                    category = ModelBuilderHelper.getCategory(value);
                    categoryClass.addCategory(category);
                }
                category.addTerm(term);
            } catch (ModelBuilderException e) {
                // Oo
                loggingError(i + 1, e);
            }
        }        
    }

    /**
     * pubNO[vo[Wݒ肵܂B
     * 
     * @param publicGroupSet pubNO[vZbg
     * @param list o[Wi[郊Xg
     */
    private void setVersion(PublicGroupSet publicGroupSet, List list) {
        
        for (int i = 0; i < list.size(); i++) {
            List value = (List) list.get(i);
            try {
                // o[Wǉ
                Version version = ModelBuilderHelper.getVersion(value);
                
                publicGroupSet.addVersion(version);
            } catch (ModelBuilderException e) {
                // Oo
                loggingError(i + 1, e);
            }
        }        
    }

    /**
     * pubNO[vݒ肵܂B
     * 
     * @param publicGroupSet pubNO[vZbg
     * @param list o[Wi[郊Xg
     */
    private void setInclusion(PublicGroupSet publicGroupSet, List list) {

        // o[W̃Zbg
        Set versions = new HashSet();

        for (int i = 0; i < list.size(); i++) {
            List value = (List) list.get(i);
            try {
                // o[WR[h
                String versionCode = (String) value.get(0);
                // qpubNO[vR[h
                String child = (String) value.get(1);
                // epubNO[vR[h
                String parent = (String) value.get(2);
                
                // Kw\z
                publicGroupSet.setStruct(versionCode, parent, child);
                
                if (publicGroupSet.getRoot().getPublicGroupCode().equals(child)) {
                    versions.add(versionCode);
                }
            } catch (ModelBuilderException e) {
                // Oo
                loggingError(i + 1, e);
            }
        }

        // [gvfݒ肳ꂽǂ
        Version[] version = publicGroupSet.getVersions();
        for (int i = 0; i < version.length; i++) {
            if (!versions.contains(version[i].getVersionCode())) {
                // [gvfݒ肳ĂȂ
                loggingError("MW-224", new String[] { publicGroupSet.getPublicGroupSetCode(),
                        version[i].getVersionCode() });
            }
        }        
        
        // \zꂽKw\ǂ
        Map invalidStruct = publicGroupSet.getInvalidStruct();
        if (!invalidStruct.isEmpty()) {
            
            // bZ[W쐬
            StringBuffer buffer = new StringBuffer();
            for (Iterator it = invalidStruct.keySet().iterator(); it.hasNext(); ) {
                String versionCode = (String) it.next();
                buffer.append("[").append(versionCode).append("=[");
                Set set = (Set) invalidStruct.get(versionCode);
                for (Iterator it2 = set.iterator(); it2.hasNext(); ) {
                    buffer.append(((PublicGroup) it2.next()).getPublicGroupCode());
                    buffer.append(",");
                }
                buffer.delete(buffer.length() - 1, buffer.length());
                buffer.append("]]");
            }

            // Oo
            loggingError("MW-218", new String[] {
                    publicGroupSet.getPublicGroupSetCode(), buffer.toString() });
        }
    }
}
