package jp.co.intra_mart.tools.bm5.csv2xml.models.public_group;

import java.io.Serializable;
import java.util.HashMap;
import java.util.Locale;
import java.util.Map;

import jp.co.intra_mart.tools.bm5.csv2xml.models.common.ModelBuilderException;
import jp.co.intra_mart.tools.bm5.csv2xml.models.common.Term;

/**
 * pubNO[vԉɊւ郂fłB
 * 
 * @since 5.1
 * @author INTRAMART
 * @version 1.0
 */
public class PublicGroupTerm implements Serializable {
    /**
     * pubNO[v
     */
    private PublicGroup publicGroup = null;
    /**
     * 
     */
    private final Term term;
    /**
     * puO[v̊ԍۉɊ֘Ã}bv
     */
    private Map locales = new HashMap();
    
    /**
     * RXgN^
     * 
     * @param term 
     */
    public PublicGroupTerm(Term term) {
        this.term = term;
    }
    
    /**
     * ԂԂ܂B
     * 
     * @return 
     */
    public Term getTerm() {
        return this.term;
    }
    
    /**
     * w肳ꂽɑ΂ԍۉݒ肵܂B
     * 
     * @param locale iP[j
     * @param model ԍۉ
     */
    public void addTerminableInternational(PublicGroupTermI18n model) {
        if (locales.containsKey(model.getLocale())) {
            // łɓo^ς݂̊ԍۉ񂪂
            throw new ModelBuilderException("MW-214", new String[] {
                    getPublicGroup().getPublicGroupSetCode(),
                    getPublicGroup().getPublicGroupCode(), getTerm().toString(),
                    model.getLocale().toString() });
        }
        this.locales.put(model.getLocale(), model);
        model.setPublicGroupTerm(this);
    }

    /**
     * w肳ꂽɑ΂ԍۉ擾܂B
     * 
     * @param locale iP[j
     * @return ԍۉ
     */
    public PublicGroupTermI18n getTerminableInternational(Locale locale) {
        if (!locales.containsKey(locale)) {
            // Yԍۉ񂪑݂Ȃ
            throw new ModelBuilderException("MW-215", new String[] {
                    getPublicGroup().getPublicGroupSetCode(),
                    getPublicGroup().getPublicGroupCode(), getTerm().toString(),
                    locale.toString() });
        }
        return (PublicGroupTermI18n) this.locales.get(locale);
    }
    
    /**
     * ԍۉ̈ꗗ擾܂B
     * 
     * @return ԍۉ̈ꗗ
     */
    public PublicGroupTermI18n[] getTerminableInternationals() {
        return (PublicGroupTermI18n[]) locales.values().toArray(
                new PublicGroupTermI18n[locales.size()]);
    }

    /**
     * pubNO[vݒ肵܂B
     * 
     * @param publicGroup pubNO[v
     */
    void setPublicGroup(PublicGroup publicGroup) {
        this.publicGroup = publicGroup;
    }
    
    /**
     * pubNO[v擾܂B
     * 
     * @return pubNO[v
     */
    PublicGroup getPublicGroup() {
        return this.publicGroup;
    }
}
