package jp.co.intra_mart.tools.bm5.csv2xml.models.user;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.Locale;

import jp.co.intra_mart.common.aid.jdk.java.util.LocaleUtil;
import jp.co.intra_mart.tools.bm5.csv2xml.common.Const;
import jp.co.intra_mart.tools.bm5.csv2xml.models.common.Term;
import jp.co.intra_mart.tools.bm5.csv2xml.models.common.ValueConverter;

/**
 * AJEg̃fłB
 * 
 * @since 5.1
 * @author INTRAMART
 * @version 1.0
 */
public class Account implements Serializable {
    /**
     * [UR[h
     */
    private final String userCode;
    /**
     * P[
     */
    private Locale locale = null;
    /**
     * GR[fBO
     */
    private String encoding = null;
    /**
     * pX[h
     */
    private String password = null;
    /**
     * oCpX[h
     */
    private String mobilePassword = null;
    /**
     * l
     */
    private String notes = null;
    /**
     * L
     */    
//    private Term term = Term.getDefaultTerm();
    private Term term = null;
    /**
     * OotO
     */    
    private Boolean goOut = Boolean.FALSE;
    /**
     * Cy[Wp^[
     */
    private String mainPageParttern = null;
    /**
     * J[p^[
     */
    private String colorParttern = null;
    /**
     * CZX
     */
    private Boolean license = Boolean.FALSE;
    /**
     * [
     */
    private List roles = new ArrayList();
    /**
     * AvP[V[
     */
    private List applicationRoles = new ArrayList();
    
    /**
     * RXgN^
     * 
     * @param userCode [UR[h
     */
    public Account(String userCode) {
        ValueConverter.checkNull(Const.USER_CODE, userCode);
        this.userCode = userCode;
    }
    
    /**
     * [UR[h擾܂B
     * 
     * @return [UR[h
     */
    public String getUserCode() {
        return this.userCode;
    }
    
    /**
     * P[擾܂B
     * 
     * @return P[
     */
    public Locale getLocale() {
        return locale;
    }

    /**
     * P[ݒ肵܂B
     * 
     * @param locale P[
     */
    public void setLocale(String locale) {
        if (locale != null) {
            this.locale = LocaleUtil.toLocale(locale);
        }
    }

    /**
     * GR[fBO擾܂B
     * 
     * @return GR[fBO
     */
    public String getEncoding() {
        return encoding;
    }

    /**
     * GR[fBOݒ肵܂B
     * 
     * @param encoding GR[fBO
     */
    public void setEncoding(String encoding) {
        this.encoding = encoding;
    }

    /**
     * pX[h擾܂B
     * 
     * @return pX[h
     */
    public String getPassword() {
        return password;
    }

    /**
     * pX[hݒ肵܂B
     * 
     * @param password pX[h
     */
    public void setPassword(String password) {
        this.password = password;
    }

    /**
     * oCpX[h擾܂B
     * 
     * @return oCpX[h
     */
    public String getMobilePassword() {
        return mobilePassword;
    }

    /**
     * oCpX[hݒ肵܂B
     * 
     * @param mobilePassword oCpX[h
     */
    public void setMobilePassword(String mobilePassword) {
        this.mobilePassword = mobilePassword;
    }

    /**
     * l擾܂B
     * 
     * @return l
     */
    public String getNotes() {
        return notes;
    }

    /**
     * lݒ肵܂B
     * 
     * @param notes l
     */
    public void setNotes(String notes) {
        this.notes = notes;
    }

    /**
     * Ԃ擾܂B
     * 
     * @return 
     */
    public Term getTerm() {
        return term;
    }

    /**
     * Ԃݒ肵܂B
     * 
     * @param activation LJn
     * @param expiration LI
     */
    public void setTerm(String activation, String expiration) {
        this.term = new Term(activation, expiration);
    }

    /**
     * OotO擾܂B
     * 
     * @return OotO
     */
    public Boolean getGoOut() {
        return goOut;
    }

    /**
     * OotOݒ肵܂B
     * 
     * @param goOut OotO
     */
    public void setGoOut(String goOut) {
        this.goOut = ValueConverter.toBoolean(goOut, Boolean.FALSE);
    }

    /**
     * Cy[Wp^[ID擾܂B
     * 
     * @return Cy[Wp^[ID
     */
    public String getMainPageParttern() {
        return mainPageParttern;
    }

    /**
     * Cy[Wp^[IDݒ肵܂B
     * 
     * @param mainPageParttern Cy[Wp^[ID
     */
    public void setMainPageParttern(String mainPageParttern) {
        this.mainPageParttern = mainPageParttern;
    }

    /**
     * J[p^[擾܂B
     * 
     * @return J[p^[
     */
    public String getColorParttern() {
        return colorParttern;
    }

    /**
     * J[p^[ݒ肵܂B
     * 
     * @param colorParttern J[p^[
     */
    public void setColorParttern(String colorParttern) {
        this.colorParttern = colorParttern;
    }

    /**
     * CZX擾܂B
     * 
     * @return CZX
     */
    public Boolean getLicense() {
        return license;
    }

    /**
     * CZXݒ肵܂B
     * 
     * @param license CZX
     */
    public void setLicense(String license) {
        this.license = ValueConverter.toBoolean(license, Boolean.FALSE);
    }
    
    /**
     * [ݒ肵܂B
     * 
     * @param role [
     */
    public void addRole(Role role) {
//        if (roles.contains(role)) {
//            // ̃[񂪐ݒ肳ꂽ
//            throw new ModelBuilderException("MW-301", new String[] {
//                    getUserCode(), role.getRoleId() });
//        }
        this.roles.add(role);
        role.setAccount(this);
    }

    /**
     * [̈ꗗ擾܂B
     * 
     * @return [̈ꗗ
     */
    public Role[] getRoles() {
        return (Role[]) roles.toArray(new Role[roles.size()]);
    }

    /**
     * AvP[V[ݒ肵܂B
     * 
     * @param applicationRole AvP[V[
     */
    public void addApplicationRole(ApplicationRole applicationRole) {
//        if (applicationRoles.contains(applicationRole)) {
//            // ̃AvP[V[ID񂪐ݒ肳ꂽ
//            throw new ModelBuilderException("MW-302", new String[] {
//                    getUserCode(), applicationRole.getApplicationRole() });
//        }
        this.applicationRoles.add(applicationRole);
        applicationRole.setAccount(this);
    }
    
    /**
     * AvP[V[̈ꗗ擾܂B
     * 
     * @return AvP[V[̈ꗗ
     */
    public ApplicationRole[] getApplicationRoles() {
        return (ApplicationRole[]) applicationRoles
                .toArray(new ApplicationRole[applicationRoles.size()]);    
    }
    

    public int hashCode() {
        return getUserCode().hashCode();
    }
    
    public boolean equals(Object obj) {
        if (obj == null || !(obj instanceof Account)) {
            return false;
        }
        return (this.hashCode() == obj.hashCode());
    }
}
