package jp.co.intra_mart.tools.bm5.csv2xml.models.user;

import java.io.Serializable;
import java.util.SortedMap;
import java.util.TreeMap;

import jp.co.intra_mart.tools.bm5.csv2xml.common.Const;
import jp.co.intra_mart.tools.bm5.csv2xml.models.common.ModelBuilderException;
import jp.co.intra_mart.tools.bm5.csv2xml.models.common.Term;
import jp.co.intra_mart.tools.bm5.csv2xml.models.common.ValueConverter;
import jp.co.intra_mart.tools.bm5.csv2xml.models.company.Department;

/**
 * gDɊւ郂fłB
 * 
 * @since 5.1
 * @author INTRAMART
 * @version 1.0
 */
public class DepartmentMember implements Serializable {
    /**
     * Џ
     */
    private CompanyMember companyMember = null;
    /**
     * gD
     */
    private final Department department;
    /**
     * \[gL[
     */
    private int sortKey = 0;
    /**
     * ԏ
     */
    private SortedMap terms = new TreeMap();
    
    /**
     * RXgN^
     * 
     * @param department
     */
    DepartmentMember(Department department) {
        this.department = department;
    }
    
    /**
     * ЃR[h擾܂B
     * 
     * @return ЃR[h
     */
    public String getComanyCode() {
        return this.department.getCompanyCode();
    }
    
    /**
     * gDR[h擾܂B
     * 
     * @return gDR[h
     */
    public String getDepartmentCode() {
        return this.department.getDepartmentCode();
    }
    
    /**
     * \[gL[ݒ肵܂B
     * 
     * @param sortKey \[gL[
     */
    public void setSortKey(String sortKey) {
        this.sortKey = ValueConverter.toInt(Const.SORT_KEY, sortKey);
    }
    
    /**
     * \[gL[ݒ肵܂B
     * 
     * @return \[gL[
     */
    public int getSortKey() {
        return this.sortKey;
    }
    
    /**
     * Ԃݒ肵܂B
     * 
     * @param term 
     */
    public void addTerm(Term term, String postCode) {
        try {
            if (terms.containsKey(term)) {
                // ̊Ԃ݂̏
                throw new ModelBuilderException("MW-317", new String[] {
                        getCompanyMember().getUser().getUserCode(),
                        getComanyCode(), getDepartmentCode(), term.toString() });
            }
            
            terms.put(term, postCode);
        } catch (IllegalArgumentException e) {
            // ԂdȂ鏊񂪑݂
            throw new ModelBuilderException("MW-318", new String[] {
                    getCompanyMember().getUser().getUserCode(),
                    getComanyCode(), getDepartmentCode(), term.toString() });
        }
    }
    
    /**
     * Ԃ̈ꗗ擾܂B
     * 
     * @return Ԃ̈ꗗ
     */
    public Term[] getTerms() {
        return (Term[]) terms.keySet().toArray(new Term[terms.size()]); 
    }
    
    /**
     * w肳ꂽԂ̖ER[h擾܂B
     * 
     * @param term 
     * @return ER[h
     */
    public String getPostCode(Term term) {
        return (String) terms.get(term);
    }

    /**
     * Џݒ肵܂B
     * 
     * @param companyMember Џ
     */
    void setCompanyMember(CompanyMember companyMember) {
        this.companyMember = companyMember;
    }
    /**
     * Џ擾܂B
     * 
     * @return Џ
     */
    CompanyMember getCompanyMember() {
        return this.companyMember;
    }
}
