package jp.co.intra_mart.tools.bm5.csv2xml.models.user;

import java.io.Serializable;
import java.util.SortedSet;
import java.util.TreeSet;

import jp.co.intra_mart.tools.bm5.csv2xml.common.Const;
import jp.co.intra_mart.tools.bm5.csv2xml.models.common.ModelBuilderException;
import jp.co.intra_mart.tools.bm5.csv2xml.models.common.Term;
import jp.co.intra_mart.tools.bm5.csv2xml.models.common.ValueConverter;
import jp.co.intra_mart.tools.bm5.csv2xml.models.public_group.PublicGroup;

/**
 * pubNO[vɊւ郂fłB
 * 
 * @since 5.1
 * @author INTRAMART
 * @version 1.0
 */
public class PublicGroupMember implements Serializable {
    /**
     * pubNO[vZbg
     */
    private PublicGroupSetMember setMember = null;
    /**
     * pubNO[v
     */
    private final PublicGroup publicGroup;
    /**
     * \[gL[
     */
    private int sortKey = 0;
    /**
     * 
     */
    private SortedSet terms = new TreeSet();
    
    /**
     * RXgN^
     * 
     * @param publicGroup pubNO[v
     */
    PublicGroupMember(PublicGroup publicGroup) {
        this.publicGroup = publicGroup;
    }
    
    /**
     * pubNO[vZbgR[h擾܂B
     * 
     * @return pubNO[vZbgR[h
     */
    public String getPublicGroupSetCode() {
        return this.publicGroup.getPublicGroupSetCode();
    }
    
    /**
     * pubNO[vR[h擾܂B
     * 
     * @return pubNO[vR[h
     */
    public String getPublicGroupCode() {
        return this.publicGroup.getPublicGroupCode();
    }
    
    /**
     * \[gL[ݒ肵܂B
     * 
     * @param sortKey \[gL[
     */
    public void setSortKey(String sortKey) {
        this.sortKey = ValueConverter.toInt(Const.SORT_KEY, sortKey);
    }
    
    /**
     * \[gL[ݒ肵܂B
     * 
     * @return \[gL[
     */
    public int getSortKey() {
        return this.sortKey;
    }
    
    /**
     * Ԃݒ肵܂B
     * 
     * @param term 
     */
    public void addTerm(Term term) {
        try {
            if (terms.contains(term)) {
                // ̊Ԃ݂̏
                throw new ModelBuilderException("MW-322", new String[] {
                        getPublicGroupSetMember().getUser().getUserCode(),
                        getPublicGroupSetCode(), getPublicGroupCode(), term.toString() });
            }
            
            terms.add(term);
        } catch (IllegalArgumentException e) {
            // ԂdȂ鏊񂪑݂
            throw new ModelBuilderException("MW-323", new String[] {
                    getPublicGroupSetMember().getUser().getUserCode(),
                    getPublicGroupSetCode(), getPublicGroupCode(), term.toString() });
        }
    }
    
    /**
     * Ԃ̈ꗗ擾܂B
     * 
     * @return Ԃ̈ꗗ
     */
    public Term[] getTerms() {
        return (Term[]) terms.toArray(new Term[terms.size()]); 
    }

    /**
     * pubNO[vZbgݒ肵܂B
     * 
     * @param setMember pubNO[vZbg
     */
    void setPublicGroupSetMember(PublicGroupSetMember setMember) {
        this.setMember = setMember;
    }
    /**
     * pubNO[vZbg擾܂B
     * 
     * @return pubNO[vZbg
     */
    PublicGroupSetMember getPublicGroupSetMember() {
        return this.setMember;
    }
}
