package jp.co.intra_mart.tools.bm5.csv2xml.models.user;

import java.io.Serializable;
import java.util.HashMap;
import java.util.Map;

import jp.co.intra_mart.tools.bm5.csv2xml.models.common.ModelBuilderException;
import jp.co.intra_mart.tools.bm5.csv2xml.models.public_group.PublicGroupSet;

/**
 * pubNO[vZbgɊւ郂fłB
 * 
 * @since 5.1
 * @author INTRAMART
 * @version 1.0
 */
public class PublicGroupSetMember implements Serializable {
    /**
     * [U
     */
    private User user = null;
    /**
     * pubNO[vZbg
     */
    private final PublicGroupSet publicGroupSet;
    /**
     * gD
     */
    private Map members = new HashMap();
    
    /**
     * RXgN^
     * 
     * @param publicGroupSet pubNO[vZbg
     */
    public PublicGroupSetMember(PublicGroupSet publicGroupSet) {
        this.publicGroupSet = publicGroupSet;
    }
    
    /**
     * pubNO[vZbgR[h擾܂B
     * 
     * @return pubNO[vZbgR[h
     */
    public String getPublicGroupSetCode() {
        return publicGroupSet.getPublicGroupSetCode();
    }
    
    /**
     * pubNO[vݒ肵܂B
     * 
     * @param member 
     */
    public void addPublicGroupMember(PublicGroupMember member) {
        if (members.containsKey(member.getPublicGroupCode())) {
            // pubNO[v݂
            throw new ModelBuilderException("MW-319", new String[] {
                    user.getUserCode(), getPublicGroupSetCode(),
                    member.getPublicGroupCode() });
        }
        members.put(member.getPublicGroupCode(), member);
        member.setPublicGroupSetMember(this);
    }
    
    /**
     * w肳ꂽpubNO[vR[hɈv鏊擾܂B
     * 
     * @param publicGroupCode pubNO[vR[h
     * @return pubNO[v
     */
    public PublicGroupMember getPublicGroupMember(String publicGroupCode) {
        return (PublicGroupMember) members.get(publicGroupCode);
    }
    
    /**
     * pubNO[v̈ꗗ擾܂B
     * 
     * @return pubNO[v̈ꗗ
     */
    public PublicGroupMember[] getPublicGroupMembers() {
        return (PublicGroupMember[]) members.values().toArray(new PublicGroupMember[members.size()]);
    }

    /**
     * [Uݒ肵܂B
     * 
     * @param user [U
     */
    void setUser(User user) {
        this.user = user;
    }
    /**
     * [U擾܂B
     * 
     * @return [U
     */
    User getUser() {
        return this.user;
    }
}
