/*
 * User.java
 *
 * Created on 2005/03/31, 12:00:00
 */
package jp.co.intra_mart.tools.bm5.csv2xml.models.user;

import java.io.Serializable;
import java.util.HashMap;
import java.util.Map;
import java.util.SortedMap;
import java.util.TreeMap;

import jp.co.intra_mart.tools.bm5.csv2xml.common.Const;
import jp.co.intra_mart.tools.bm5.csv2xml.models.common.ModelBuilderException;
import jp.co.intra_mart.tools.bm5.csv2xml.models.common.Term;
import jp.co.intra_mart.tools.bm5.csv2xml.models.common.ValueConverter;


/**
 * [Ů{̃f[^舵܂B
 *
 * @since 5.1
 * @author INTRAMART
 * @version 1.0
 */
public class User implements Serializable {
    /**
     * [UR[h
     */
    private String userCode;
    /**
     * l
     */
    private String notes;
    /**
     * \[gL[
     */
    private int sortKey;
    /**
     * [ŮԉɊ֘Ã}bv
     */
    private SortedMap terms = new TreeMap();
    /**
     * 及Ǘ郊Xg
     */
    private SortedMap mains = new TreeMap();
    /**
     * gDǗ}bv
     */
    private Map companies = new HashMap();
    /**
     * pubNO[vǗ}bv
     */
    private Map groups = new HashMap();
    
    /**
     * RXgN^
     * 
     * @param userCode [UR[h
     */
    public User(String userCode) {
        ValueConverter.checkNull(Const.USER_CODE, userCode);
        this.userCode = userCode;
    }
    
    /**
     * ԉǉ܂B
     * 
     * @param model [Uԉ
     */
    public void addUserTerminable(UserTerm model) {
        try {
            // Ԃłɓo^Ăꍇ
            if (terms.containsKey(model.getTerm())) {
                // ̊ԉ񂪑݂
                throw new ModelBuilderException("MW-303", new String[] {
                        getUserCode(), model.getTerm().toString() });
            }
            this.terms.put(model.getTerm(), model);
            model.setUser(this);
        } catch (IllegalArgumentException e) {
            // ̊ԉ񂪑݂
            throw new ModelBuilderException("MW-304", new String[] {
                    getUserCode(), model.getTerm().toString() });
        }
    }
    
    /**
     * ԉ擾܂B
     * 
     * @param term 
     * @return ԉ
     */
    public UserTerm getUserTerm(Term term) {
        try {
            if (!terms.containsKey(term)) {
                // YԉK݂Ȃ
                throw new ModelBuilderException("MW-305", new String[] {
                        getUserCode(), term.toString() });
            }
            
            return (UserTerm) terms.get(term);
        } catch (IllegalArgumentException e) {
            // YԉK݂Ȃ
            throw new ModelBuilderException("MW-305", new String[] {
                    getUserCode(), term.toString() });
        }
    }
    
    /**
     * ԉ̈ꗗ擾܂B
     * 
     * @return ԉ̈ꗗ
     */
    public UserTerm[] getUserTerms() {
        return (UserTerm[]) terms.values().toArray(new UserTerm[terms.size()]);
    }
    
    /**
     * ԉ񂪑݂邩ǂ
     * 
     * @return @։񂪑݂ꍇtrueAȊOfalse
     */
    public boolean isTerminable() {
        return terms.size() > 0;
    }

    /**
     * [UR[h擾܂B
     * 
     * @return [UR[h
     */
    public String getUserCode() {
        return this.userCode;
    }

    /**
     * l擾܂B
     * 
     * @return l
     */
    public String getNotes() {
        return this.notes;
    }

    /**
     * lݒ肵܂B
     * 
     * @param notes l
     */
    public void setNotes(String notes) {
        this.notes = notes;
    }
    /**
     * \[gL[擾܂B
     * 
     * @return \[gL[
     */
    public int getSortKey() {
        return this.sortKey;
    }

    /**
     * \[gL[ݒ肵܂B
     * 
     * @param sortKey \[gL[
     */
    public void setSortKey(String sortKey) {
        this.sortKey = ValueConverter.toInt(Const.SORT_KEY, sortKey);
    }
    
    /**
     * gD及ݒ肵܂B
     * 
     * @param member 及
     */
    public void addMainMember(MainMember member) {
        try {
            if (mains.containsKey(member.getTerm())) {
                // ̎及񂪑݂
                throw new ModelBuilderException("MW-306", new String[] {
                        getUserCode(), member.getCompanyCode(),
                        member.getDepartmentCode() });
            }

            mains.put(member.getTerm(), member);
        } catch (IllegalArgumentException e) {
            // ԂdȂ及݂
            throw new ModelBuilderException("MW-307", new String[] {
                    getUserCode(), member.getCompanyCode(),
                    member.getDepartmentCode(), member.getTerm().toString() });
        }
    }
    
    /**
     * 及̈ꗗԂ܂B
     * 
     * @return 及̈ꗗ
     */
    public MainMember[] getMainMembers() {
        return (MainMember[]) mains.values().toArray(new MainMember[mains.size()]);
    }

    /**
     * Џݒ肵܂B
     * 
     * @param member Џ
     */
    public void addCompanyMember(CompanyMember member) {
        if (companies.containsKey(member.getCompanyCode())) {
            // ̉Ђɑ΂鏊񂪑݂
            throw new ModelBuilderException("MW-308", new String[] {
                    getUserCode(), member.getCompanyCode() });
        }
        companies.put(member.getCompanyCode(), member);
        member.setUser(this);
    }
    
    /**
     * ЏԂ܂B
     * 
     * @param department gD
     */
    public CompanyMember getCompanyMember(String companyCode) {
        return (CompanyMember) companies.get(companyCode);
    }
    
    /**
     * Џ̈ꗗԂ܂B
     * 
     * @return Џ̈ꗗ
     */
    public CompanyMember[] getCompanyMembers() {
        return (CompanyMember[]) companies.values().toArray(
                new CompanyMember[companies.size()]);
    }

    /**
     * pubNO[vZbgݒ肵܂B
     * 
     * @param member pubNO[vZbg
     */
    public void addPublicGroupSetMember(PublicGroupSetMember member) {
        if (groups.containsKey(member.getPublicGroupSetCode())) {
            // ̃pubNO[vZbgɑ΂鏊񂪑݂
            throw new ModelBuilderException("MW-309", new String[] {
                    getUserCode(), member.getPublicGroupSetCode() });
        }
        groups.put(member.getPublicGroupSetCode(), member);
        member.setUser(this);
    }
    
    /**
     * pubNO[vZbg擾܂B
     * 
     * @param publicGroupSetCode pubNO[vZbgR[h
     */
    public PublicGroupSetMember getPublicGroupSetMember(String publicGroupSetCode) {
        return (PublicGroupSetMember) groups.get(publicGroupSetCode);
    }
    
    /**
     * pubNO[vZbg̈ꗗԂ܂B
     * 
     * @return pubNO[vZbg̈ꗗ
     */
    public PublicGroupSetMember[] getPublicGroupSetMembers() {
        return (PublicGroupSetMember[]) groups.values().toArray(
                new PublicGroupSetMember[groups.size()]);
    }
    
    public int hashCode() {
        return getUserCode().hashCode();
    }
    
    public boolean equals(Object obj) {
        if (obj == null || !(obj instanceof User)) {
            return false;
        }
        return (this.hashCode() == obj.hashCode());
    }

}