package jp.co.intra_mart.tools.bm5.csv2xml.models.user;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import jp.co.intra_mart.tools.bm5.csv2xml.models.common.ModelBuilderException;

/**
 * [Uێ}bvłB
 * 
 * @since 5.1
 * @author INTRAMART
 * @version 1.0
 */
public class UserMap implements Serializable {
    /**
     * [U(vt@C)̃Xg
     */
    private List userList = new ArrayList();
    /**
     * [U(vt@C)̃}bv
     */
    private Map userMap = new HashMap();
    /**
     * AJEg̃Xg
     */
    private List accountList = new ArrayList();
    /**
     * AJEg̃}bv
     */
    private Map accountMap = new HashMap();
    
    /**
     * [Uݒ肵܂B
     * 
     * @param user
     */
    public void addUser(User user) {
        if (existUser(user.getUserCode())) {
            // ̃[U݂
            throw new ModelBuilderException("MW-312", user.getUserCode());
        }
        
        userMap.put(user.getUserCode(), user);
        userList.add(user);
    }

    /**
     * w肳ꂽ[UR[hɈv郆[UԂ܂B
     * 
     * @param userCode [UR[h
     * @return [U
     */
    public User getUser(String userCode) {
        if (!existUser(userCode)) {
            // Y郆[U݂Ȃ
            throw new ModelBuilderException("MW-313", userCode);
        }
        return (User) userMap.get(userCode);
    }
    
    /**
     * [Üꗗ擾܂B
     * 
     * @return [Üꗗ
     */
    public User[] getUsers() {
        return (User[]) userList.toArray(new User[userList.size()]);
    }
    
    /**
     * w肳ꂽ[UR[hɈv郆[U݂邩ǂ
     * 
     * @param userCode [UR[h
     * @return [U񂪑݂ꍇtrueAȊOfalse
     */
    public boolean existUser(String userCode) {
        return userMap.containsKey(userCode);
    }
    
    /**
     * AJEgݒ肵܂B
     * 
     * @param account
     */
    public void addAccount(Account account) {
        if (existAccount(account.getUserCode())) {
            // ̃AJEg݂
            throw new ModelBuilderException("MW-314", account.getUserCode());
        }
        
        accountMap.put(account.getUserCode(), account);
        accountList.add(account);
    }

    /**
     * w肳ꂽ[UR[hɈvAJEgԂ܂B
     * 
     * @param userCode [UR[h
     * @return [U
     */
    public Account getAccount(String userCode) {
        if (!existAccount(userCode)) {
            // YAJEg݂Ȃ
            throw new ModelBuilderException("MW-313", userCode);
        }
        return (Account) accountMap.get(userCode);
    }
    
    /**
     * AJEg̈ꗗ擾܂B
     * 
     * @return AJEg̈ꗗ
     */
    public Account[] getAccounts() {
        return (Account[]) accountList.toArray(new Account[accountList.size()]);
    }
    
    /**
     * w肳ꂽ[UR[hɈvAJEg񂪈v邩ǂ
     * 
     * @param userCode [UR[h
     * @return AJEg񂪑݂ꍇtrueAȊOfalse
     */
    public boolean existAccount(String userCode) {
        return accountMap.containsKey(userCode);
    }
}
