package jp.co.intra_mart.tools.bm5.csv2xml.models.user;

import java.util.Iterator;
import java.util.List;
import java.util.Map;

import jp.co.intra_mart.tools.bm5.csv2xml.common.Const;
import jp.co.intra_mart.tools.bm5.csv2xml.models.ModelBuilder;
import jp.co.intra_mart.tools.bm5.csv2xml.models.common.ModelBuilderException;
import jp.co.intra_mart.tools.bm5.csv2xml.models.common.ModelBuilderHelper;
import jp.co.intra_mart.tools.bm5.csv2xml.models.common.ModelBuilderTemplate;
import jp.co.intra_mart.tools.bm5.csv2xml.models.common.Term;
import jp.co.intra_mart.tools.bm5.csv2xml.models.common.ValueConverter;
import jp.co.intra_mart.tools.bm5.csv2xml.models.company.Company;
import jp.co.intra_mart.tools.bm5.csv2xml.models.company.CompanyMap;
import jp.co.intra_mart.tools.bm5.csv2xml.models.company.Department;
import jp.co.intra_mart.tools.bm5.csv2xml.models.public_group.PublicGroup;
import jp.co.intra_mart.tools.bm5.csv2xml.models.public_group.PublicGroupSet;
import jp.co.intra_mart.tools.bm5.csv2xml.models.public_group.PublicGroupSetMap;

/**
 * AJEgуvt@C̃f̐s܂B
 * 
 * @since 5.1
 * @author INTRAMART
 * @version 1.0
 */
public class UserModelBuilder extends ModelBuilderTemplate implements ModelBuilder {

    /**
     * ReLXgCSVǂݍނ߂̃L[擾܂B
     * 
     * @return L[
     */
    protected String getContextReadKey() {
        return Const.USER;
    }

    /**
     * ReLXgɃfނ߂̃L[擾܂B
     * 
     * @return L[
     */
    protected String getContextWriteKey() {
        return Const.USER_MODEL;
    }

    /**
     * f̐s܂B
     * 
     * @param input ̓f[^
     * @return f
     */    
    public Object createModel(Object input) {
        
        // [U(vt@C)f
        UserMap userMap = new UserMap();

        Map root = (Map) input;
        
        // {fݒ
        List lines = (List) root.get(Const.USER_BASE);
        setExecuteFile(lines);
        setBaseModel(userMap, lines);      

        // [fݒ
        lines = (List) root.get(Const.USER_ROLE);
        if (lines != null) {
            setExecuteFile(lines);
            setRoleModel(userMap, lines);
        }
        
        // AvP[V[fݒ
        lines = (List) root.get(Const.USER_APPLICATION_ROLE);
        if (lines != null) {
            setExecuteFile(lines);
            setApplicationRoleModel(userMap, lines);
        }
        
        // ԉ񂪐ݒ肳Ăꍇ̂ݏs
        lines = (List) root.get(Const.USER_TERM);
        if (lines != null) {
            // ԉfݒ
            setExecuteFile(lines);
            setTermModel(userMap, lines);
            
            // ԍۉfݒ
            Map locales = (Map) root.get(Const.USER_TERM_I18N);
            if (locales != null) {
                setTermI18nModel(userMap, locales);
            }
            
            // gDfݒ
            lines = (List) root.get(Const.USER_DEPARTMENT_ATTACH);
            CompanyMap companyMap = (CompanyMap) getContext().getParameter(Const.COMPANY_MODEL);
            if (lines != null && companyMap != null) {
                setExecuteFile(lines);
                setDepartmentMemberModel(userMap, lines, companyMap);
            }

            // pubNO[vfݒ
            lines = (List) root.get(Const.USER_PUBLC_GROUP_ATTACH);
            PublicGroupSetMap groupMap = (PublicGroupSetMap) 
                        getContext().getParameter(Const.PUBLIC_GROUP_MODEL);
            if (lines != null && groupMap != null) {
                setExecuteFile(lines);
                setPublicGroupMemberModel(userMap, lines, groupMap);
            }
        }
        
        return userMap;
    }

    /**
     * [Ů{񂨂уAJEgݒ肵܂B
     *
     * @param userMap [Ũ}bv
     * @param list [Ů{i[郊Xg
     */
    private void setBaseModel(UserMap userMap, List list) {
        
        for (int i = 0; i < list.size(); i++) {
            List data = (List) list.get(i);
            try {
                // AJEgݒ
                Account account = ModelBuilderHelper.getAccount(data);
                userMap.addAccount(account);
            } catch (ModelBuilderException e) {
                // Oo
                loggingError(i + 1, e);
            }

            try {
                // [Uvt@Cݒ
                User user = ModelBuilderHelper.getUser(data);
                userMap.addUser(user);
            } catch (ModelBuilderException e) {
                // Oo
                loggingError(i + 1, e);
            }
        }
    }
    
    /**
     * [Ůԉݒ肵܂B
     * 
     * @param userMap [Ũ}bv
     * @param list [Ůԉi[郊Xg
     */
    private void setTermModel(UserMap userMap, List list) {
        
        for (int i = 0; i < list.size(); i++) {
            List data = (List) list.get(i);
            try {
                // [U
                User user = userMap.getUser((String) data.get(0));
                // 
                Term term = new Term((String) data.get(1), (String) data.get(2));
                
                // [Uԉfǉ
                UserTerm userTerm = ModelBuilderHelper.getUserTerm(term, data);
                user.addUserTerminable(userTerm);
            } catch (ModelBuilderException e) {
                // Oo
                loggingError(i + 1, e);
            }
        }
    }

    /**
     * [Ůԉݒ肵܂B
     * 
     * @param userMap [Ũ}bv
     * @param locales ۉi[}bv
     */
    private void setTermI18nModel(UserMap userMap, Map locales) {
        
        for (Iterator it = locales.keySet().iterator(); it.hasNext(); ) {
            String locale = (String) it.next();
            List lines = (List) locales.get(locale);
            setExecuteFile(lines);
            setTermI18nModel(userMap, locale, (List) lines);
        }
    }

    /**
     * [Ůԉݒ肵܂B
     * 
     * @param userMap [Ũ}bv
     * @param list [Ůԉi[郊Xg
     */
    private void setTermI18nModel(UserMap userMap, String locale, List list) {
        
        for (int i = 0; i < list.size(); i++) {
            List value = (List) list.get(i);
            try {
                // [U
                User user = userMap.getUser((String) value.get(0));
                // 
                Term term = new Term((String) value.get(1), (String) value.get(2));
                
                // ԍۉfǉ
                UserTermI18n userTermI18n = ModelBuilderHelper.getUserTermI18n(locale, value);

                user.getUserTerm(term).addTerminableInternational(userTermI18n);
            } catch (ModelBuilderException e) {
                // Oo
                loggingError(i + 1, e);
            }
        }
    }

    /**
     * [ȖgDݒ肵܂B
     * 
     * @param userMap [Ũ}bv
     * @param list [ȖgDi[郊Xg
     * @param companyMap Ѓ}bv
     */
    private void setDepartmentMemberModel(UserMap userMap, List list,
            CompanyMap companyMap) {
        
        for (int i = 0; i < list.size(); i++) {
            List value = (List) list.get(i);
            try {
                // [U
                User user = userMap.getUser((String) value.get(0));
                // 
                Company company = companyMap.getCompany((String) value.get(1));
                // gD
                Department department = company.getDepartment((String) value.get(2));
                // 
                Term term = new Term((String) value.get(3), (String) value.get(4));
                
                // gDԉ݂邩ǂ
                if (department.getTerms().length == 0) {
                    
                    // gDԉĂȂ
                    throw new ModelBuilderException("MW-320", new String[] {
                            user.getUserCode(), company.getCompanyCode(),
                            department.getDepartmentCode() });
                }
                
                // ݒ
                Boolean isMain = ValueConverter.toBoolean((String) value.get(6), Boolean.TRUE);
                if (Boolean.TRUE.equals(isMain)) {
                    // 及ݒ肳Ăꍇ
                    user.addMainMember(new MainMember(department, term));
                }
                
                // ()
                CompanyMember companyMember = user.getCompanyMember(company.getCompanyCode());
                if (companyMember == null) {
                    companyMember = new CompanyMember(company);
                    user.addCompanyMember(companyMember);
                }
                
                DepartmentMember member = companyMember
                        .getDepartmentMember(department.getDepartmentCode());
                if (member == null) {
                    member = new DepartmentMember(department);
                    companyMember.addDepartmentMember(member);
                }
                member.addTerm(term, (String) value.get(5));
            } catch (ModelBuilderException e) {
                // Oo
                loggingError(i + 1, e);
            }
        }
    }

    /**
     * [ŨpubNO[vݒ肵܂B
     * 
     * @param userMap [Ũ}bv
     * @param list [ŨpubNO[vi[郊Xg
     * @param groupSetMap pubNO[vZbg}bv
     */
    private void setPublicGroupMemberModel(UserMap userMap, List list,
            PublicGroupSetMap groupSetMap) {

        for (int i = 0; i < list.size(); i++) {
            List value = (List) list.get(i);
            try {
                // [U
                User user = userMap.getUser((String) value.get(0));
                // pubNO[vZbg
                PublicGroupSet groupSet = groupSetMap.getPublicGroupSet((String) value.get(1));
                // pubNO[v
                PublicGroup group = groupSet.getPublicGroup((String) value.get(2));
                // 
                Term term = new Term((String) value.get(3), (String) value.get(4));
                
                // pubNO[vԉ݂邩ǂ
                if (group.getTerms().length == 0) {
                    // pubNO[vԉĂȂ
                    throw new ModelBuilderException("MW-321", new String[] {
                            user.getUserCode(), groupSet.getPublicGroupSetCode(),
                            group.getPublicGroupCode() });
                }
                
                // ݒ
                PublicGroupSetMember setMember = user
                        .getPublicGroupSetMember(groupSet.getPublicGroupSetCode());
                if (setMember == null) {
                    setMember = new PublicGroupSetMember(groupSet);
                    user.addPublicGroupSetMember(setMember);
                }
                
                PublicGroupMember member = setMember.getPublicGroupMember(group
                        .getPublicGroupCode());
                if (member == null) {
                    member = new PublicGroupMember(group);
                    setMember.addPublicGroupMember(member);
                }
                member.addTerm(term);
            } catch (ModelBuilderException e) {
                // Oo
                loggingError(i + 1, e);
            }
        }        
    }
    
    /**
     * [Ũ[ݒ肵܂B
     * 
     * @param userMap [Ũ}bv
     * @param list [Ũ[i[郊Xg
     */
    private void setRoleModel(UserMap userMap, List list) {
        
        for (int i = 0; i < list.size(); i++) {
            List value = (List) list.get(i);
            try {
                // [
                Role role = ModelBuilderHelper.getRole(value);
                
                // AJEg
                Account account = userMap.getAccount((String) value.get(0));
                account.addRole(role);
            } catch (ModelBuilderException e) {
                // Oo
                loggingError(i + 1, e);
            }
        }
    }
    
    /**
     * [ŨAvP[V[ݒ肵܂B
     * 
     * @param userMap [Ũ}bv
     * @param list [ŨAvP[V[i[郊Xg
     */
    private void setApplicationRoleModel(UserMap userMap, List list) {
        
        for (int i = 0; i < list.size(); i++) {
            List value = (List) list.get(i);
            try {
                // AvP[V[
                ApplicationRole role = ModelBuilderHelper.getApplicationRole(value);
                
                // AJEg
                Account account = userMap.getAccount((String) value.get(0));
                account.addApplicationRole(role);
            } catch (ModelBuilderException e) {
                // Oo
                loggingError(i + 1, e);
            }
        }
    }
}
