/*
 * UserTerminable.java
 *
 * Created on 2005/03/31, 12:00:00
 */
package jp.co.intra_mart.tools.bm5.csv2xml.models.user;

import java.io.Serializable;
import java.util.HashMap;
import java.util.Locale;
import java.util.Map;

import jp.co.intra_mart.tools.bm5.csv2xml.models.common.ModelBuilderException;
import jp.co.intra_mart.tools.bm5.csv2xml.models.common.Term;

/**
 * [Ůԉ̃f[^舵܂B
 *
 * @since 5.1
 * @author INTRAMART
 * @version 1.0
 */
public class UserTerm implements Serializable {
    /**
     * [U
     */
    private User user = null;
    /**
     * 
     */
    private final Term term;
    /**
     * dbԍ
     */
    private String telephoneNumber;
    /**
     * gѓdbԍ
     */
    private String mobileNumber;
    /**
     * FAXԍ
     */
    private String faxNumber;
    /**
     * ԍ
     */
    private String extensionNumber;
    /**
     * FAXԍ
     */
    private String extensionFaxNumber;
    /**
     * R[h
     */
    private String countryCode;
    /**
     * X֔ԍ
     */
    private String zipCode;
    /**
     * [AhXP
     */
    private String emailAddress1;
    /**
     * [AhXQ
     */
    private String emailAddress2;
    /**
     * gїp[
     */
    private String mobileEmailAddress;
    /**
     * URL
     */
    private String url;
    /**
     * [ŮԍۉɊ֘Ã}bv
     */
    private Map locales = new HashMap();

    /**
     * RXgN^
     * 
     * @param term 
     */
    public UserTerm(Term term) {
        this.term = term;
    }
    
    /**
     * Ԃ擾܂B
     * 
     * @return 
     */
    public Term getTerm() {
        return this.term;
    }
    
    /**
     * ԍۉfݒ肵܂B
     * 
     * @param locale 
     * @param model [Uԍۉf
     */
    public void addTerminableInternational(UserTermI18n model) {
        if (locales.containsKey(model.getLocale())) {
            // ̌̊ԍۉ݂
            throw new ModelBuilderException("MW-310", new String[] {
                    getUser().getUserCode(), getTerm().toString(),
                    model.getLocale().toString() });
        }
        this.locales.put(model.getLocale(), model);
    }
    
    /**
     * w肳ꂽɈvԍۉ擾܂B
     * 
     * @param locale 
     * @return ԍۉ
     */
    public UserTermI18n getTerminableInternational(Locale locale) {
        if (!locales.containsKey(locale)) {
            // Ɉvԍۉ݂Ȃ
            throw new ModelBuilderException("MW-311", new String[] {
                    getUser().getUserCode(), getTerm().toString(),
                    locale.toString() });
        }
        return (UserTermI18n) locales.get(locale);
    }

    /**
     * ԍۉ̈ꗗ擾܂B
     * 
     * @return ԍۉ̈ꗗ
     */
    public UserTermI18n[] getTerminableInternationals() {
        return (UserTermI18n[]) locales.values().toArray(new UserTermI18n[locales.size()]);
    }

    /**
     * dbԍ擾܂B
     * 
     * @return dbԍ
     */
    public String getTelephoneNumber() {
        return this.telephoneNumber;
    }

    /**
     * dbԍݒ肵܂B
     * 
     * @param telephoneNumber dbԍ
     */
    public void setTelephoneNumber(String telephoneNumber) {
        this.telephoneNumber = telephoneNumber;
    }

    /**
     * gѓdbԍ擾܂B
     * 
     * @return gѓdbԍ
     */
    public String getMobileNumber() {
        return this.mobileNumber;
    }

    /**
     * gѓdbԍݒ肵܂B
     * 
     * @param mobileNumber gѓdbԍ
     */
    public void setMobileNumber(String mobileNumber) {
        this.mobileNumber = mobileNumber;
    }

    /**
     * FAXԍ擾܂B
     * 
     * @return FAXԍ
     */
    public String getFaxNumber() {
        return this.faxNumber;
    }

    /**
     * FAXԍݒ肵܂B
     * 
     * @param faxNumber FAXԍ
     */
    public void setFaxNumber(String faxNumber) {
        this.faxNumber = faxNumber;
    }

    /**
     * ԍ擾܂B
     * 
     * @return ԍ
     */
    public String getExtensionNumber() {
        return this.extensionNumber;
    }

    /**
     * ԍݒ肵܂B
     * 
     * @param extensionNumber ԍ
     */
    public void setExtensionNumber(String extensionNumber) {
        this.extensionNumber = extensionNumber;
    }

    /**
     * FAXԍ擾܂B
     * 
     * @return FAXԍ
     */
    public String getExtensionFaxNumber() {
        return this.extensionFaxNumber;
    }

    /**
     * FAXԍݒ肵܂B
     * 
     * @param extensionFaxNumber FAXԍ
     */
    public void setExtensionFaxNumber(String extensionFaxNumber) {
        this.extensionFaxNumber = extensionFaxNumber;
    }

    /**
     * R[h擾܂B
     * 
     * @return R[h
     */
    public String getCountryCode() {
        return this.countryCode;
    }

    /**
     * R[hݒ肵܂B
     * 
     * @param countryCode R[h
     */
    public void setCountryCode(String countryCode) {
        this.countryCode = countryCode;
    }

    /**
     * X֔ԍ擾܂B
     * 
     * @return X֔ԍ
     */
    public String getZipCode() {
        return this.zipCode;
    }

    /**
     * X֔ԍݒ肵܂B
     * 
     * @param zipCode X֔ԍ
     */
    public void setZipCode(String zipCode) {
        this.zipCode = zipCode;
    }

    /**
     * [AhXP擾܂B
     * 
     * @return [AhXP
     */
    public String getEmailAddress1() {
        return this.emailAddress1;
    }

    /**
     * [AhXPݒ肵܂B
     * 
     * @param emailAddress1 [AhXP
     */
    public void setEmailAddress1(String emailAddress1) {
        this.emailAddress1 = emailAddress1;
    }

    /**
     * [AhXQ擾܂B
     * 
     * @return [AhXQ
     */
    public String getEmailAddress2() {
        return this.emailAddress2;
    }

    /**
     * [AhXQݒ肵܂B
     * 
     * @param emailAddress2 [AhXQ
     */
    public void setEmailAddress2(String emailAddress2) {
        this.emailAddress2 = emailAddress2;
    }

    /**
     * gїp[擾܂B
     * 
     * @return gїp[
     */
    public String getMobileEmailAddress() {
        return this.mobileEmailAddress;
    }

    /**
     * gїp[ݒ肵܂B
     * 
     * @param mobileEmailAddress gїp[
     */
    public void setMobileEmailAddress(String mobileEmailAddress) {
        this.mobileEmailAddress = mobileEmailAddress;
    }

    /**
     * URL擾܂B
     * 
     * @return URL
     */
    public String getUrl() {
        return this.url;
    }

    /**
     * URLݒ肵܂B
     * 
     * @param url URL
     */
    public void setUrl(String url) {
        this.url = url;
    }
    
    /**
     * [Uݒ肵܂B
     * 
     * @param user [U
     */
    void setUser(User user) {
        this.user = user;
    }
    
    /**
     * [U擾܂B
     * 
     * @return [U
     */
    User getUser() {
        return this.user;
    }
}