package jp.co.intra_mart.tools.bm5.csv2xml.read;

/**
 * all the methode of the CsvData
 *
 */
public interface CsvData
{
    /**
     * get the row
     * 
     * @param index
     * @return
     */
    public DataList getRow(int index);
    
    /**
     * get the column
     * 
     * @param index
     * @return
     */
    public DataList getColumn(int index);
    
    /**
     * get the value
     * 
     * @param rowIndex
     * @param columnIndex
     * @return
     */
    public String getString(int rowIndex, int columnIndex);
    
    /**
     * clear the row
     * 
     * @param index
     */
    public void clearRow(int index);
    
    /**
     * replace the row
     * 
     * @param index
     * @param rowValue
     */
    public void replaceRow(int index, DataList rowValue);
    
    /**
     * set the value
     * 
     * @param rowIndex
     * @param columnIndex
     * @param value
     */
    public void setString(int rowIndex, int columnIndex, String value);
    
    /**
     * set the row's error message number
     * 
     * @param rowIndex
     * @param columnIndex
     * @param errNumber
     */
    public void setRowErrorMessageNo(int rowIndex, 
    		    String columnIndex, String errNumber);
    
    /**
     * get the row's error message number
     * 
     * @param rowIndex
     * @return
     */
    public String getRowErrorMessageNo(int rowIndex);
    
    public void setErrorMessageNo(String errNumber);
    
    public String getErrorMessageNo();
    
    public String getRowErrorColumnNo(int rowIndex);
    
    /**
     * clear the error message number of the row
     *
     */
    public void clearRowErrorMessage();

    /**
     * delete the row
     * 
     * @param index
     */
    public void deleteRow(int index);
    
    /**
     * get the name of the csv file
     * 
     * @return the name of the csv file
     */
    public String getCsvFileName();
    
    /**
     * get the path of the csv file
     * 
     * @return the path of the csv file
     */
    public String getCsvFilePath();
    
    /**
     * get the row's count
     * 
     * @return the row's count
     */
    public int RowCount();
    
    /**
     * get the column's count
     * 
     * @return the column's count
     */
    public int ColumnCount();
}
