package jp.co.intra_mart.tools.bm5.csv2xml.util;

import java.util.ArrayList;

import jp.co.intra_mart.tools.bm5.csv2xml.read.CsvData;
import jp.co.intra_mart.tools.bm5.csv2xml.read.DataList;

/**
 * CSVIuWFNgE[eBeB
 * 
 * @since 5.1
 * @author INTRAMART
 * @version 1.0
 */
public class CsvUtil {
    /**
     * change the csv data to safely
     * 
     * @param line
     * @return
     */
    public static CsvFileModel toLineSafely(String line) {
        CsvFileModel list = new CsvFileModel();
        int start = 0;

        String value = null;
        line = line.trim();
        start = line.indexOf("\"");

        if (start != -1) {
            if (start > 0) {
                String subLine = line.substring(0, start - 1);
                addValue(list, subLine);
            }

            line = line.substring(start);
            for (int i = 0; i < line.length(); i++) {
                if (line.startsWith("\"")) {
                    if (line.indexOf("\",") > 1) {
                        start = getEndIndex(line) + 1;
                        if (start == line.length() + 1) {
                            addMultipValue(list, line);
                            break;
                        }
                        value = line.substring(0, start);
                        addMultipValue(list, value);
                        line = line.substring(start);
                        if (line.equals(",")) {
                            line = "";
                            i = -2;
                        } else {
                            line = line.substring(1);
                            i = -1;
                        }
                    } else {
                        value = line;
                        addMultipValue(list, value);
                        break;
                    }
                } else {
                    start = line.indexOf("\"");
                    if (start == -1) {
                        addValue(list, line);
                        break;
                    } else {
                        value = line.substring(0, start - 1);
                        addValue(list, value);
                        line = line.substring(start);
                        i = -1;
                    }
                }
            }
        } else {
            addValue(list, line);
        }
        return list;
    }

    private static void addValue(ArrayList list, String valueString) {
        String value = null;

        int from = 0;
        int to = 0;
        while ((to = valueString.indexOf(',', from)) != -1) {
            value = valueString.substring(from, to);
            list.add(value);
            from = to + 1;
        }
        value = valueString.substring(from);
        list.add(value);
    }

    private static void addMultipValue(ArrayList list, String valueString) {
        StringBuffer ret = new StringBuffer();
        String value = null;
        if (valueString.startsWith("\"") && valueString.endsWith("\"")) {
            for (int i = 1; i < valueString.length() - 1; i++) {
                String strSub = valueString.substring(i, i + 2);
                //""
                if (strSub.equals("\"\"")) {
                    ret.append("\"");
                    i = i + 1;
                } else {
                    ret.append(valueString.charAt(i));
                }
            }
            value = ret.toString();
            list.add(value);
        }
    }

    private static int getEndIndex(String value) {
        int index = -1;
        int count = 0;
        if (value.startsWith("\"")) {
            for (int i = 0; i < value.length() - 1; i++) {
                if (value.charAt(i) == '\"') {
                    count = count + 1;
                    if (value.substring(i, i + 2).equals("\",")
                            && count % 2 == 0) {
                        index = i;
                        break;
                    }
                }
            }
            if (index == -1) {
                index = value.length();
            }
        }
        return index;
    }

    public static void toCsvDataSafe(CsvData csvData, String mainCode,
            int mainColumn) {
        if (csvData != null) {
            for (int i = 1; i <= csvData.RowCount(); i++) {
                DataList row = csvData.getRow(i);
                if (row != null) {
                    String value = row.getString(mainColumn);
                    if (mainCode.equals(value)) {
                        csvData.clearRow(i);
                    }
                }
            }
        }
    }
}